## ia32-libs-core 20110202

=== Makefile ===
# Copyright (C) 1991-2002,2003,2004,2005,2006,2008,2009
#	Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Master Makefile for the GNU C library
#
ifneq (,)
This makefile requires GNU Make.
endif

include Makeconfig


# This is the default target; it makes everything except the tests.
.PHONY: all
all: lib others

ifneq ($(AUTOCONF),no)

ifeq ($(with-cvs),yes)
define autoconf-it-cvs
test ! -d CVS || cvs $(CVSOPTS) commit -m'Regenerated: autoconf $(ACFLAGS) $<' $@
endef
else
autoconf-it-cvs =
endif

define autoconf-it
@-rm -f $@.new
$(AUTOCONF) $(ACFLAGS) $< > $@.new
chmod a-w$(patsubst %,$(comma)a+x,$(filter .,$(@D))) $@.new
mv -f $@.new $@
$(autoconf-it-cvs)
endef

configure: configure.in aclocal.m4; $(autoconf-it)
%/configure: %/configure.in aclocal.m4; $(autoconf-it)
%/preconfigure: %/preconfigure.in aclocal.m4; $(autoconf-it)

endif # $(AUTOCONF) = no


# We don't want to run anything here in parallel.
.NOTPARALLEL:

# These are the targets that are made by making them in each subdirectory.
+subdir_targets	:= subdir_lib objects objs others subdir_mostlyclean	\
		   subdir_clean subdir_distclean subdir_realclean	\
		   tests xtests subdir_lint.out				\
		   subdir_update-abi subdir_check-abi 			\
		   subdir_echo-headers 					\
		   subdir_install					\
		   subdir_objs subdir_stubs subdir_testclean		\
		   $(addprefix install-, no-libc.a bin lib data headers others)

headers := limits.h values.h features.h gnu-versions.h bits/libc-lock.h \
	   bits/xopen_lim.h gnu/libc-version.h bits/predefs.h

echo-headers: subdir_echo-headers

# The headers are in the include directory.
subdir-dirs = include
vpath %.h $(subdir-dirs)

# What to install.
install-bin-script =

# If we're bootstrapping, install a dummy gnu/stubs.h along with the
# other headers, so 'make install-headers' produces a useable include
# tree.  Otherwise, install gnu/stubs.h later, after the rest of the
# build is done.
ifeq ($(install-bootstrap-headers),yes)
install-headers: $(inst_includedir)/gnu/stubs.h
else
install-others = $(inst_includedir)/gnu/stubs.h
endif

ifeq (yes,$(build-shared))
headers += gnu/lib-names.h
endif

include Makerules

ifeq ($(build-programs),yes)
others: $(addprefix $(objpfx),$(install-bin-script))
endif

# Install from subdirectories too.
install: subdir_install

# Explicit dependency so that `make install-headers' works
install-headers: install-headers-nosubdir

# Make sure that the dynamic linker is installed before libc.
$(inst_slibdir)/libc-$(version).so: elf/ldso_install

.PHONY: elf/ldso_install
elf/ldso_install:
	$(MAKE) -C $(@D) $(@F)

# Create links for shared libraries using the `ldconfig' program if possible.
# Ignore the error if we cannot update /etc/ld.so.cache.
ifeq (no,$(cross-compiling))
ifeq (yes,$(build-shared))
install: install-symbolic-link
.PHONY: install-symbolic-link
install-symbolic-link: subdir_install
	$(symbolic-link-prog) $(symbolic-link-list)
	rm -f $(symbolic-link-list)

install:
	-test ! -x $(common-objpfx)elf/ldconfig || LC_ALL=C LANGUAGE=C \
	  $(common-objpfx)elf/ldconfig $(addprefix -r ,$(install_root)) \
				       $(slibdir) $(libdir)
ifneq (no,$(PERL))
ifeq (/usr,$(prefix))
ifeq (,$(install_root))
	CC="$(CC)" $(PERL) scripts/test-installation.pl $(common-objpfx)
endif
endif
endif
endif
endif

# Build subdirectory lib objects.
lib-noranlib: subdir_lib

ifeq (yes,$(build-shared))
# Build the shared object from the PIC object library.
lib: $(common-objpfx)libc.so
endif


# This is a handy script for running any dynamically linked program against
# the current libc build for testing.
$(common-objpfx)testrun.sh: $(common-objpfx)config.make \
			    $(..)Makeconfig $(..)Makefile
	(echo '#!/bin/sh'; \
	 echo "GCONV_PATH='$(common-objpfx)iconvdata' \\"; \
	 echo 'exec $(run-program-prefix) $${1+"$$@"}'; \
	) > $@T
	chmod a+x $@T
	mv -f $@T $@
postclean-generated += testrun.sh

others: $(common-objpfx)testrun.sh

# Makerules creates a file `stubs' in each subdirectory, which
# contains `#define __stub_FUNCTION' for each function defined in that
# directory which is a stub.
# Here we paste all of these together into <gnu/stubs.h>.

subdir-stubs := $(foreach dir,$(subdirs),$(common-objpfx)$(dir)/stubs)

# gnu/stubs.h depends (via the subdir 'stubs' targets) on all the .o
# files in EGLIBC.  For bootstrapping a GCC/EGLIBC pair, an empty
# gnu/stubs.h is good enough.
ifeq ($(install-bootstrap-headers),yes)
$(inst_includedir)/gnu/stubs.h: include/stubs-bootstrap.h $(+force)
	$(make-target-directory)
	$(INSTALL_DATA) $< $@

installed-stubs = 
else 
ifeq ($(biarch),no)
installed-stubs = $(inst_includedir)/gnu/stubs.h
else
installed-stubs = $(inst_includedir)/gnu/stubs-$(biarch).h

$(inst_includedir)/gnu/stubs.h: include/stubs-biarch.h $(+force)
	$(make-target-directory)
	$(INSTALL_DATA) $< $@

install-others-nosubdir: $(installed-stubs)
endif
endif


# Since stubs.h is never needed when building the library, we simplify the
# hairy installation process by producing it in place only as the last part
# of the top-level `make install'.  It depends on subdir_install, which
# iterates over all the subdirs; subdir_install in each subdir depends on
# the subdir's stubs file.  Having more direct dependencies would result in
# extra iterations over the list for subdirs and many recursive makes.
$(installed-stubs): include/stubs-prologue.h subdir_install
	$(make-target-directory)
	@rm -f $(objpfx)stubs.h
	(sed '/^@/d' $<; LC_ALL=C sort $(subdir-stubs)) > $(objpfx)stubs.h
	if test -r $@ && cmp -s $(objpfx)stubs.h $@; \
	then echo 'stubs.h unchanged'; \
	else $(INSTALL_DATA) $(objpfx)stubs.h $@; fi
	rm -f $(objpfx)stubs.h

# This makes the Info or DVI file of the documentation from the Texinfo source.
.PHONY: info dvi pdf html
info dvi pdf html:
	$(MAKE) $(PARALLELMFLAGS) -C manual $@

# This makes all the subdirectory targets.

# For each target, make it depend on DIR/target for each subdirectory DIR.
$(+subdir_targets): %: $(addsuffix /%,$(subdirs))

# Compute a list of all those targets.
all-subdirs-targets := $(foreach dir,$(subdirs),\
				 $(addprefix $(dir)/,$(+subdir_targets)))

# The action for each of those is to cd into the directory and make the
# target there.
$(all-subdirs-targets):
	$(MAKE) $(PARALLELMFLAGS) $(subdir-target-args) $(@F)

define subdir-target-args
subdir=$(@D)$(if $($(@D)-srcdir),\
-C $($(@D)-srcdir) ..=`pwd`/,\
-C $(@D) ..=../)
endef

.PHONY: $(+subdir_targets) $(all-subdirs-targets)

# Targets to clean things up to various degrees.

.PHONY: clean realclean distclean distclean-1 parent-clean parent-mostlyclean \
	tests-clean

# Subroutines of all cleaning targets.
parent-mostlyclean: common-mostlyclean # common-mostlyclean is in Makerules.
	-rm -f $(foreach o,$(object-suffixes-for-libc),\
		   $(common-objpfx)$(patsubst %,$(libtype$o),c)) \
	       $(addprefix $(objpfx),$(install-lib))
parent-clean: parent-mostlyclean common-clean

postclean = $(addprefix $(common-objpfx),$(postclean-generated)) \
	    $(addprefix $(objpfx),sysd-dirs sysd-rules) \
	    $(addprefix $(objpfx),sysd-sorted soversions.mk soversions.i)

clean: parent-clean
# This is done this way rather than having `subdir_clean' be a
# dependency of this target so that libc.a will be removed before the
# subdirectories are dealt with and so they won't try to remove object
# files from it when it's going to be removed anyway.
	@$(MAKE) subdir_clean no_deps=t
	-rm -f $(postclean)
mostlyclean: parent-mostlyclean
	@$(MAKE) subdir_mostlyclean no_deps=t
	-rm -f $(postclean)

tests-clean:
	@$(MAKE) subdir_testclean no_deps=t

tests: $(objpfx)c++-types-check.out $(objpfx)check-local-headers.out
ifneq ($(CXX),no)
check-data := $(firstword $(wildcard \
	        $(foreach D,$(add-ons) scripts,\
	        	  $(patsubst %,$D/data/c++-types-%.data,\
			   	     $(abi-name) \
			   	     $(addsuffix -$(config-os),\
				     		 $(config-machine) \
						 $(base-machine))))))
ifneq (,$(check-data))
$(objpfx)c++-types-check.out: $(check-data) scripts/check-c++-types.sh
	scripts/check-c++-types.sh $< $(CXX) $(filter-out -std=gnu99 -Wstrict-prototypes,$(CFLAGS)) $(CPPFLAGS) > $@
else
$(objpfx)c++-types-check.out:
	@echo 'WARNING C++ tests not run; create a c++-types-XXX file'
	@echo "not run" > $@
endif
endif

$(objpfx)check-local-headers.out: scripts/check-local-headers.sh
	scripts/check-local-headers.sh "$(includedir)" "$(objpfx)" > $@

ifneq ($(PERL),no)
installed-headers = argp/argp.h assert/assert.h catgets/nl_types.h \
		    crypt/crypt.h ctype/ctype.h debug/execinfo.h \
		    dirent/dirent.h dlfcn/dlfcn.h elf/elf.h elf/link.h \
		    gmon/sys/gmon.h gmon/sys/gmon_out.h gmon/sys/profil.h \
		    grp/grp.h gshadow/gshadow.h iconv/iconv.h iconv/gconv.h \
		    $(wildcard inet/netinet/*.h) \
		    $(wildcard inet/arpa/*.h inet/protocols/*.h) \
		    inet/aliases.h inet/ifaddrs.h inet/netinet/ip6.h \
		    inet/netinet/icmp6.h intl/libintl.h io/sys/stat.h \
		    io/sys/statfs.h io/sys/vfs.h io/sys/statvfs.h \
		    io/fcntl.h io/sys/fcntl.h io/poll.h io/sys/poll.h \
		    io/utime.h io/ftw.h io/fts.h io/sys/sendfile.h \
		    libio/stdio.h libio/libio.h locale/locale.h \
		    locale/langinfo.h locale/xlocale.h login/utmp.h \
		    login/lastlog.h login/pty.h malloc/malloc.h \
		    malloc/obstack.h malloc/mcheck.h math/math.h \
		    math/complex.h math/fenv.h math/tgmath.h misc/sys/uio.h \
		    $(wildcard nis/rpcsvc/*.h) nptl_db/thread_db.h \
		    nptl/sysdeps/pthread/pthread.h nptl/semaphore.h \
		    nss/nss.h posix/sys/utsname.h posix/sys/times.h \
		    posix/sys/wait.h posix/sys/types.h posix/unistd.h \
		    posix/glob.h posix/regex.h posix/wordexp.h posix/fnmatch.h\
		    posix/getopt.h posix/tar.h posix/sys/unistd.h \
		    posix/sched.h posix/re_comp.h posix/wait.h \
		    posix/cpio.h posix/spawn.h pwd/pwd.h resolv/resolv.h \
		    resolv/netdb.h $(wildcard resolv/arpa/*.h) \
		    resource/sys/resource.h resource/sys/vlimit.h \
		    resource/sys/vtimes.h resource/ulimit.h rt/aio.h \
		    rt/mqueue.h setjmp/setjmp.h shadow/shadow.h \
		    signal/signal.h signal/sys/signal.h socket/sys/socket.h \
		    socket/sys/un.h stdio-common/printf.h \
		    stdio-common/stdio_ext.h stdlib/stdlib.h stdlib/alloca.h \
		    stdlib/monetary.h stdlib/fmtmsg.h stdlib/ucontext.h \
		    sysdeps/generic/inttypes.h sysdeps/generic/stdint.h \
		    stdlib/errno.h stdlib/sys/errno.h string/string.h \
		    string/strings.h string/memory.h string/endian.h \
		    string/argz.h string/envz.h string/byteswap.h \
		    $(wildcard sunrpc/rpc/*.h sunrpc/rpcsvc/*.h) \
		    sysvipc/sys/ipc.h sysvipc/sys/msg.h sysvipc/sys/sem.h \
		    sysvipc/sys/shm.h termios/termios.h \
		    termios/sys/termios.h termios/sys/ttychars.h time/time.h \
		    time/sys/time.h time/sys/timeb.h wcsmbs/wchar.h \
		    wctype/wctype.h

tests: $(objpfx)begin-end-check.out
$(objpfx)begin-end-check.out: scripts/begin-end-check.pl
	$(PERL) scripts/begin-end-check.pl $(installed-headers) > $@
endif

# The realclean target is just like distclean for the parent, but we want
# the subdirs to know the difference in case they care.
realclean distclean: parent-clean
# This is done this way rather than having `subdir_distclean' be a

=== argp/Makefile ===
# Copyright (C) 1997,2002,2003,2006,2007,2010 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Makefile for argp.
#
include ../option-groups.mak

subdir	:= argp

headers		= argp.h
distribute	= argp-fmtstream.h argp-namefrob.h
routines	= $(addprefix argp-, ba fmtstream fs-xinl help parse pv \
				     pvh xinl eexst)

tests		= argp-test tst-argp1 bug-argp1 tst-argp2 bug-argp2

CFLAGS-argp-help.c = $(uses-callbacks) -fexceptions
CFLAGS-argp-parse.c = $(uses-callbacks)
CFLAGS-argp-fmtstream.c = -fexceptions

bug-argp1-ARGS = -- --help
bug-argp2-ARGS = -- -d 111 --dstaddr 222 -p 333 --peer 444

include ../Rules

=== elf/Makefile ===
# Copyright (C) 1995-2007, 2008, 2009 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

# Makefile for elf subdirectory of GNU C Library.

subdir		:= elf

headers		= elf.h bits/elfclass.h link.h bits/link.h
routines	= $(dl-routines) dl-support dl-iteratephdr \
		  dl-addr enbl-secure dl-profstub \
		  dl-origin dl-libc dl-sym dl-tsd dl-sysdep

# The core dynamic linking functions are in libc for the static and
# profiled libraries.
dl-routines	= $(addprefix dl-,load cache lookup object reloc deps \
			          runtime error init fini debug misc \
				  version profile conflict tls origin scope \
				  execstack caller open close trampoline)
all-dl-routines = $(dl-routines) $(sysdep-dl-routines)
# But they are absent from the shared libc, because that code is in ld.so.
elide-routines.os = $(all-dl-routines) dl-support enbl-secure dl-origin \
		    dl-sysdep
shared-only-routines += dl-caller

# ld.so uses those routines, plus some special stuff for being the program
# interpreter and operating independent of libc.
rtld-routines	:= rtld $(dl-routines) dl-sysdep dl-environ dl-minimal
all-rtld-routines = $(rtld-routines) $(sysdep-rtld-routines)

distribute	:= rtld-Rules \
		   $(rtld-routines:=.c) dynamic-link.h do-rel.h dl-machine.h \
		   dl-cache.h dl-hash.h soinit.c sofini.c ldd.bash.in \
		   genrtldtbl.awk atomicity.h dl-procinfo.h ldsodefs.h \
		   dl-librecon.h interp.c sln.c dl-dst.h hp-timing.h \
		   dl-lookupcfg.h sprof.c gen-trusted-dirs.awk \
		   testobj1.c testobj2.c testobj3.c testobj4.c testobj5.c \
		   testobj6.c testobj1_1.c failobj.c unloadmod.c \
		   ldconfig.h ldconfig.c cache.c readlib.c readelflib.c \
		   chroot_canon.c gccframe.h \
		   dep1.c dep2.c dep3.c dep4.c dl-dtprocnum.h unsecvars.h \
		   vismain.c vismod1.c vismod2.c vismod3.c \
		   constload2.c constload3.c filtmod1.c filtmod2.c \
		   nodlopenmod.c nodelete.c nodelmod1.c nodelmod2.c \
		   nodelmod3.c nodelmod4.c nodlopen.c dl-osinfo.h \
		   reldepmod1.c reldepmod2.c reldepmod3.c reldepmod4.c \
		   reldepmod5.c reldepmod6.c \
		   reldep4mod1.c reldep4mod2.c reldep4mod3.c reldep4mod4.c \
		   nextmod1.c nextmod2.c pathoptobj.c tst-pathopt.sh \
		   neededobj1.c neededobj2.c neededobj3.c neededobj4.c \
		   neededobj5.c neededobj6.c firstobj.c \
		   unload2mod.c unload2dep.c ltglobmod1.c ltglobmod2.c \
		   testobj.h vismod.h globalmod1.c \
		   dblloadmod1.c dblloadmod2.c dblloadmod3.c \
		   reldep6mod4.c reldep6mod3.c reldep6mod2.c reldep6mod1.c \
		   reldep6mod0.c reldep7mod1.c reldep7mod2.c \
		   unwind-dw2.c unwind-dw2-fde.c unwind.h unwind-pe.h \
		   unwind-dw2-fde.h dwarf2.h dl-procinfo.c tls.h dl-tls.h \
		   tst-tlsmod1.c tst-tlsmod2.c tst-tlsmod3.c tst-tlsmod4.c \
		   tst-tlsmod5.c tst-tlsmod6.c tst-tlsmod7.c tst-tlsmod8.c \
		   tst-tlsmod9.c tst-tlsmod10.c tst-tlsmod11.c \
		   tst-tlsmod12.c tst-tls10.h tst-alignmod.c tst-alignmod2.c \
		   circlemod1.c circlemod1a.c circlemod2.c circlemod2a.c \
		   circlemod3.c circlemod3a.c nodlopenmod2.c \
		   tls-macros.h \
		   reldep8mod1.c reldep8mod2.c reldep8mod3.c \
		   nodel2mod1.c nodel2mod2.c nodel2mod3.c \
		   reldep9.c reldep9mod1.c reldep9mod2.c reldep9mod3.c \
		   tst-array1.exp tst-array2.exp tst-array4.exp \
		   tst-array2dep.c tst-piemod1.c \
		   tst-execstack-mod.c tst-dlmodcount.c \
		   check-textrel.c dl-sysdep.h test-dlopenrpathmod.c \
		   tst-deep1mod1.c tst-deep1mod2.c tst-deep1mod3.c \
		   unload3mod1.c unload3mod2.c unload3mod3.c unload3mod4.c \
		   unload4mod1.c unload4mod2.c unload4mod3.c unload4mod4.c \
		   unload6mod1.c unload6mod2.c unload6mod3.c \
		   unload7mod1.c unload7mod2.c \
		   tst-audit1.c tst-audit2.c tst-audit3.c tst-audit4.c \
		   tst-auditmod1.c tst-auditmod3a.c tst-auditmod3b.c \
		   tst-auditmod4a.c tst-auditmod4b.c \
		   tst-audit5.c tst-auditmod5a.c tst-auditmod5b.c \
		   tst-audit6.c tst-auditmod6a.c tst-auditmod6b.c \
		   tst-auditmod6c.c \
		   tst-audit7.c tst-auditmod7a.c tst-auditmod7b.c \
		   order2mod1.c order2mod2.c order2mod3.c order2mod4.c \
		   tst-stackguard1.c tst-stackguard1-static.c \
		   tst-array5.c tst-array5-static.c tst-array5dep.c \
		   tst-array5.exp tst-leaks1.c check-execstack.c \
		   ifuncmain1.c ifuncmain1pic.c ifuncmain1vis.c \
		   ifuncmain1vispic.c ifuncmain1static.c \
		   ifuncmain1staticpic.c ifuncmain1picstatic.c \
		   ifuncdep1.c ifuncdep1pic.c ifuncmod1.c \
		   ifuncmain1pie.c ifuncmain1vispie.c \
		   ifuncmain1staticpie.c \
		   ifuncmain2.c ifuncmain2static.c ifuncdep2.c \
		   ifuncmain2pic.c ifuncmain2picstatic.c ifuncdep2pic.c \
		   ifuncmain3.c ifuncmod3.c \
		   ifuncmain4.c ifuncmain4static.c ifuncmain4picstatic.c \
		   ifuncmain5.c ifuncmain5pic.c ifuncmain5picstatic.c \
		   ifuncmain5pie.c ifuncmain5static.c \
		   ifuncmain5staticpic.c \
		   ifuncdep5.c ifuncdep5pic.c ifuncmod5.c \
		   ifuncmain6pie.c ifuncmod6.c \
		   ifuncmain7.c ifuncmain7pic.c ifuncmain7picstatic.c \
		   ifuncmain7pie.c ifuncmain7static.c \
		   tst-unique1.c tst-unique1mod1.c tst-unique1mod2.c \
		   tst-unique2.c tst-unique2mod1.c tst-unique2mod2.c

CFLAGS-dl-runtime.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-lookup.c = -fexceptions -fasynchronous-unwind-tables
CFLAGS-dl-iterate-phdr.c = $(uses-callbacks)

include ../Makeconfig

ifeq ($(unwind-find-fde),yes)
routines += unwind-dw2-fde-glibc
shared-only-routines += unwind-dw2-fde-glibc
endif

before-compile  = $(objpfx)trusted-dirs.h
generated	:= trusted-dirs.h trusted-dirs.st for-renamed/renamed.so
generated-dirs	:= for-renamed

# eglibc: ifeq ($(versioning),yes)
ld-map		= $(common-objpfx)ld.map
# eglibc: endif

ifeq (yes,$(build-shared))
extra-objs	= $(all-rtld-routines:%=%.os) soinit.os sofini.os interp.os
generated	+= librtld.os dl-allobjs.os ld.so ldd
install-others	= $(inst_slibdir)/$(rtld-installed-name)
install-bin-script = ldd
endif

others		= sprof sln
install-bin	= sprof
others-static   = sln
install-rootsbin = sln

ifeq (yes,$(use-ldconfig))
ifeq (yes,$(build-shared))
others-static	+= ldconfig
others		+= ldconfig
install-rootsbin += ldconfig

ldconfig-modules := cache readlib xmalloc xstrdup chroot_canon
extra-objs	+= $(ldconfig-modules:=.o)

# To find xmalloc.c and xstrdup.c
vpath %.c ../locale/programs

endif
endif

tests = tst-tls1 tst-tls2 tst-tls9 tst-leaks1
ifeq (yes,$(have-initfini-array))
tests += tst-array1 tst-array2 tst-array3 tst-array4 tst-array5
endif
ifeq (yes,$(build-static))
tests-static = tst-tls1-static tst-tls2-static tst-stackguard1-static
ifeq (yesyesyes,$(build-static)$(build-shared)$(elf))
tests-static += tst-tls9-static
tst-tls9-static-ENV = \
  EGLIBC_TEST_LD_LIBRARY_PATH=$(objpfx):$(common-objpfx):$(common-objpfx)dlfcn
tst-tls9-static-WRAPPER = $(..)scripts/run-with-env.sh
endif
ifeq (yes,$(have-initfini-array))
tests-static += tst-array1-static tst-array5-static
endif
tests += $(tests-static)
endif
ifeq (yes,$(build-shared))
tests += loadtest restest1 preloadtest loadfail multiload origtest resolvfail \
	 constload1 order vismain noload filter unload \
	 reldep reldep2 reldep3 reldep4 nodelete nodelete2 \
	 nodlopen nodlopen2 neededtest neededtest2 \
	 neededtest3 neededtest4 unload2 lateglobal initfirst global \
	 restest2 next dblload dblunload reldep5 reldep6 reldep7 reldep8 \
	 circleload1 tst-tls3 tst-tls4 tst-tls5 tst-tls6 tst-tls7 tst-tls8 \
	 tst-tls10 tst-tls11 tst-tls12 tst-tls13 tst-tls14 tst-tls15 \
	 tst-tls16 tst-tls17 tst-tls18 tst-tls-dlinfo \
	 tst-align tst-align2 $(tests-execstack-$(have-z-execstack)) \
	 tst-dlmodcount tst-dlopenrpath tst-deep1 \
	 tst-dlmopen1 tst-dlmopen2 tst-dlmopen3 \
	 unload3 unload4 unload5 unload6 unload7 tst-global1 order2 \
	 tst-audit1 tst-audit2 \
	 tst-stackguard1 tst-addr1 tst-thrlock \
	 tst-unique1 tst-unique2
#	 reldep9
test-srcs = tst-pathopt
tests-execstack-yes = tst-execstack tst-execstack-needed tst-execstack-prog
ifeq (x86_64,$(config-machine))
tests += tst-audit3 tst-audit4 tst-audit5 tst-audit6 tst-audit7
endif
endif
ifeq (yesyes,$(have-fpie)$(build-shared))
tests: $(objpfx)tst-pie1.out
endif
tests: $(objpfx)tst-leaks1-mem
tlsmod17a-suffixes = 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19
tlsmod18a-suffixes = 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19
modules-names = testobj1 testobj2 testobj3 testobj4 testobj5 testobj6 \
		testobj1_1 failobj constload2 constload3 unloadmod \
		dep1 dep2 dep3 dep4 vismod1 vismod2 vismod3 \
		nodelmod1 nodelmod2 nodelmod3 nodelmod4 \
		nodel2mod1 nodel2mod2 nodel2mod3 \
		nodlopenmod nodlopenmod2 filtmod1 filtmod2 \
		reldepmod1 reldepmod2 reldepmod3 reldepmod4 nextmod1 nextmod2 \
		reldep4mod1 reldep4mod2 reldep4mod3 reldep4mod4 \
		neededobj1 neededobj2 neededobj3 neededobj4 \
		neededobj5 neededobj6 firstobj globalmod1 \
		unload2mod unload2dep ltglobmod1 ltglobmod2 pathoptobj \
		dblloadmod1 dblloadmod2 dblloadmod3 reldepmod5 reldepmod6 \
	        reldep6mod0 reldep6mod1 reldep6mod2 reldep6mod3 reldep6mod4 \
		reldep7mod1 reldep7mod2 \
		tst-tlsmod1 tst-tlsmod2 tst-tlsmod3 tst-tlsmod4 \
		tst-tlsmod5 tst-tlsmod6 tst-tlsmod7 tst-tlsmod8 \
		tst-tlsmod9 tst-tlsmod10 tst-tlsmod11 tst-tlsmod12 \
		tst-tlsmod13 tst-tlsmod13a tst-tlsmod14a tst-tlsmod14b \
		tst-tlsmod15a tst-tlsmod15b tst-tlsmod16a tst-tlsmod16b \
		$(patsubst %,tst-tlsmod17a%,$(tlsmod17a-suffixes)) \
		tst-tlsmod17b \
		$(patsubst %,tst-tlsmod18a%,$(tlsmod18a-suffixes)) \
		circlemod1 circlemod1a circlemod2 circlemod2a \
		circlemod3 circlemod3a \
		reldep8mod1 reldep8mod2 reldep8mod3 \
		reldep9mod1 reldep9mod2 reldep9mod3 \
		tst-alignmod tst-alignmod2 \
		$(modules-execstack-$(have-z-execstack)) \
		tst-dlopenrpathmod tst-deep1mod1 tst-deep1mod2 tst-deep1mod3 \
		tst-dlmopen1mod tst-auditmod1 \
		unload3mod1 unload3mod2 unload3mod3 unload3mod4 \
		unload4mod1 unload4mod2 unload4mod3 unload4mod4 \
		unload6mod1 unload6mod2 unload6mod3 \
		unload7mod1 unload7mod2 \
		order2mod1 order2mod2 order2mod3 order2mod4 \
		tst-unique1mod1 tst-unique1mod2 \
		tst-unique2mod1 tst-unique2mod2
ifeq (yes,$(have-initfini-array))
modules-names += tst-array2dep tst-array5dep
endif
ifeq (yesyes,$(have-fpie)$(build-shared))
modules-names += tst-piemod1
endif
ifeq (x86_64,$(config-machine))
modules-names += tst-auditmod3a tst-auditmod3b \
		tst-auditmod4a tst-auditmod4b \
		tst-auditmod5a tst-auditmod5b \
		tst-auditmod6a tst-auditmod6b tst-auditmod6c \
		tst-auditmod7a tst-auditmod7b
endif
modules-execstack-yes = tst-execstack-mod
extra-test-objs += $(addsuffix .os,$(strip $(modules-names)))
# We need this variable to be sure the test modules get the right CPPFLAGS.
test-extras += $(modules-names)

# filtmod1.so has a special rule
modules-names-nobuild := filtmod1

ifeq (yes,$(multi-arch))
tests-static += ifuncmain1static ifuncmain1picstatic \
		ifuncmain2static ifuncmain2picstatic \
		ifuncmain4static ifuncmain4picstatic \
		ifuncmain5static ifuncmain5picstatic \
		ifuncmain7static ifuncmain7picstatic

ifeq (yes,$(build-shared))
tests += ifuncmain1 ifuncmain1pic ifuncmain1vis ifuncmain1vispic \
	 ifuncmain1staticpic \
	 ifuncmain2 ifuncmain2pic ifuncmain3 ifuncmain4 \
	 ifuncmain5 ifuncmain5pic ifuncmain5staticpic \
	 ifuncmain7 ifuncmain7pic
ifeq (yes,$(have-fpie))

=== hesiod/Makefile ===
# Copyright (C) 1997, 1998, 2000, 2001 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Sub-makefile for hesiod portion of the library.
#
include ../option-groups.mak

subdir	:= hesiod

distribute := hesiod.h hesiod_p.h README.hesiod nss_hesiod/nss_hesiod.h

extra-libs-$(OPTION_EGLIBC_INET) += libnss_hesiod
extra-libs-others-y += $(extra-libs-y)

subdir-dirs = nss_hesiod
vpath %.c nss_hesiod

libnss_hesiod-routines	:= hesiod hesiod-grp hesiod-init hesiod-proto \
                           hesiod-pwd hesiod-service
# Build only shared library
libnss_hesiod-inhibit-o	= $(filter-out .os,$(object-suffixes))

include ../Rules

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
# The Hesiod NSS modules also needs the resolver and some help from
# the file service.
$(objpfx)libnss_hesiod.so: $(common-objpfx)resolv/libresolv.so \
                           $(common-objpfx)nss/libnss_files.so \
                           $(common-objpfx)libc.so \
			   $(common-objpfx)libc_nonshared.a

=== iconv/Makefile ===
# Copyright (C) 1997,1998,2000-2004,2007,2009 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Makefile for iconv.
#
include ../option-groups.mak

subdir	:= iconv

include ../Makeconfig

headers		= iconv.h gconv.h
routines	= iconv_open iconv iconv_close \
		  gconv_open gconv gconv_close gconv_db gconv_conf \
		  gconv_builtin gconv_simple gconv_trans gconv_cache
ifeq ($(elf),yes)
routines	+= gconv_dl
else
CFLAGS-gconv_db.c = -DSTATIC_GCONV
CFLAGS-gconv_cache.c = -DSTATIC_GCONV
CFLAGS-gconv_simple.c = -DSTATIC_GCONV
endif

vpath %.c ../locale/programs ../intl

iconv_prog-modules = iconv_charmap charmap charmap-dir linereader \
		     dummy-repertoire simple-hash xstrdup xmalloc
iconvconfig-modules = strtab xmalloc hash-string
extra-objs	   = $(iconv_prog-modules:=.o) $(iconvconfig-modules:=.o)
CFLAGS-iconv_prog.c = -I../locale/programs
CFLAGS-iconv_charmap.c = -I../locale/programs
CFLAGS-dummy-repertoire.c = -I../locale/programs
CFLAGS-charmap.c = -DCHARMAP_PATH='"$(i18ndir)/charmaps"' \
		   -DDEFAULT_CHARMAP=null_pointer -DNEED_NULL_POINTER
CFLAGS-linereader.c = -DNO_TRANSLITERATION
CFLAGS-simple-hash.c = -I../locale

tests	= tst-iconv1 tst-iconv2 tst-iconv3 tst-iconv4 tst-iconv5

distribute	= gconv_builtin.h gconv_int.h loop.c skeleton.c iconv_prog.h \
		  iconv_charmap.c dummy-repertoire.c gconv_charset.h strtab.c \
		  iconvconfig.h

others		= iconv_prog iconvconfig
install-others-programs	= $(inst_bindir)/iconv
install-sbin	= iconvconfig

CFLAGS-gconv_cache.c += -DGCONV_DIR='"$(gconvdir)"'
CFLAGS-gconv_conf.c = -DGCONV_PATH='"$(gconvdir)"'
CFLAGS-iconvconfig.c = -DGCONV_PATH='"$(gconvdir)"' -DGCONV_DIR='"$(gconvdir)"'

CPPFLAGS-iconv_prog = -DNOT_IN_libc
CPPFLAGS-iconv_charmap = -DNOT_IN_libc
CPPFLAGS-iconvconfig = -DNOT_IN_libc
CPPFLAGS-linereader = -DNOT_IN_libc
CPPFLAGS-strtab = -DNOT_IN_libc
CPPFLAGS-charmap = -DNOT_IN_libc
CPPFLAGS-charmap-dir = -DNOT_IN_libc
ifneq (y,$(OPTION_EGLIBC_SPAWN))
CPPFLAGS-charmap-dir.c += -DNO_UNCOMPRESS
endif

include ../Rules

$(inst_bindir)/iconv: $(objpfx)iconv_prog $(+force)
	$(do-install-program)

$(objpfx)iconv_prog: $(iconv_prog-modules:%=$(objpfx)%.o)
$(objpfx)iconvconfig: $(iconvconfig-modules:%=$(objpfx)%.o)

# eglibc: ifneq ($(cross-compiling),yes)
xtests: test-iconvconfig
# eglibc: endif

.PHONY: test-iconvconfig
test-iconvconfig: /dev/null $(objpfx)iconvconfig
	tmp=$(objpfx)gconv-modules.cache.$$$$; \
	rm -f $$tmp; \
	$(make-test-out) --output=$$tmp --nostdlib $(inst_gconvdir) && \
	cmp $$tmp $(inst_gconvdir)/gconv-modules.cache && \
	rm -f $$tmp

=== intl/Makefile ===
# Copyright (C) 1995-2003, 2005, 2008 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

# Makefile for intl subdirectory: message handling code from GNU gettext.
include ../option-groups.mak

subdir = intl
headers = libintl.h
routines = bindtextdom dcgettext dgettext gettext	\
	   dcigettext dcngettext dngettext ngettext \
	   finddomain loadmsgcat localealias textdomain
aux =	   l10nflist explodename plural plural-exp hash-string
distribute = gmo.h gettextP.h hash-string.h loadinfo.h locale.alias \
	     plural.y plural-exp.h plural-eval.c po2test.sed \
	     tst-gettext.sh \
	     tst-translit.sh translit.po \
	     tst-gettext2.sh tstlang1.po tstlang2.po \
	     tst-codeset.sh tstcodeset.po \
	     tst-gettext3.sh \
	     tst-gettext4.sh tst-gettext4-de.po tst-gettext4-fr.po \
	     tst-gettext5.sh tst-gettext6.sh

include ../Makeconfig

multithread-test-srcs := tst-gettext4 tst-gettext5 tst-gettext6
test-srcs := tst-gettext tst-translit tst-gettext2 tst-codeset tst-gettext3
ifeq ($(have-thread-library),yes)
test-srcs += $(multithread-test-srcs)
endif
tests = tst-ngettext

before-compile = $(objpfx)msgs.h

install-others = $(inst_msgcatdir)/locale.alias

generated = msgs.h mtrace-tst-gettext tst-gettext.mtrace
generated-dirs := domaindir localedir

ifneq (no,$(BISON))
plural.c: plural.y
	$(BISON) $(BISONFLAGS) $@ $^
ifeq ($(with-cvs),yes)
	test ! -d CVS || cvs $(CVSOPTS) commit -m'$(BISON) $(BISONFLAGS) $@ $^' $@
endif
endif
$(objpfx)plural.o: plural.c

include ../Rules

# eglibc: ifeq (no,$(cross-compiling))
ifeq (yyyes,$(OPTION_EGLIBC_LOCALES)$(OPTION_EGLIBC_LOCALE_CODE)$(build-shared))
ifneq ($(strip $(MSGFMT)),:)
tests: $(objpfx)tst-translit.out $(objpfx)tst-gettext2.out \
       $(objpfx)tst-codeset.out $(objpfx)tst-gettext3.out
ifeq ($(have-thread-library),yes)
tests: $(objpfx)tst-gettext4.out $(objpfx)tst-gettext5.out \
       $(objpfx)tst-gettext6.out
endif
ifneq (no,$(PERL))
tests: $(objpfx)mtrace-tst-gettext
endif
endif
$(objpfx)mtrace-tst-gettext: $(objpfx)tst-gettext.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-gettext.mtrace > $@
$(objpfx)tst-gettext.out: tst-gettext.sh $(objpfx)tst-gettext
	$(SHELL) -e $< $(common-objpfx) $(common-objpfx)intl/ \
	  $(objpfx)tst-gettext.mtrace '$(cross-test-wrapper)'
$(objpfx)tst-translit.out: tst-translit.sh $(objpfx)tst-translit
	$(SHELL) -e $< $(common-objpfx) $(common-objpfx)intl/ \
	'$(cross-test-wrapper)'
$(objpfx)tst-gettext2.out: tst-gettext2.sh $(objpfx)tst-gettext2
	$(SHELL) -e $< $(common-objpfx) $(common-objpfx)intl/ \
	'$(cross-test-wrapper)'
$(objpfx)tst-codeset.out: tst-codeset.sh $(objpfx)tst-codeset
	$(SHELL) -e $< $(common-objpfx) $(common-objpfx)intl/ \
	'$(cross-test-wrapper)'
$(objpfx)tst-gettext3.out: tst-gettext3.sh $(objpfx)tst-gettext3
	$(SHELL) -e $< $(common-objpfx) $(common-objpfx)intl/ \
	'$(cross-test-wrapper)'
$(objpfx)tst-gettext4.out: tst-gettext4.sh $(objpfx)tst-gettext4
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)' $(common-objpfx)intl/
$(objpfx)tst-gettext5.out: tst-gettext5.sh $(objpfx)tst-gettext5
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)' $(common-objpfx)intl/
$(objpfx)tst-gettext6.out: tst-gettext6.sh $(objpfx)tst-gettext6
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)' $(common-objpfx)intl/
endif
# eglibc: endif

$(objpfx)msgs.h: po2test.sed ../po/de.po
	$(make-target-directory)
	LC_ALL=C sed -f $^ > $@

CFLAGS-tst-gettext.c = -DTESTSTRS_H=\"$(objpfx)msgs.h\"
CFLAGS-tst-translit.c = -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-gettext2.c = -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-codeset.c = -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-gettext3.c = -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-gettext4.c = -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-gettext5.c = -DOBJPFX=\"$(objpfx)\"
CFLAGS-tst-gettext6.c = -DOBJPFX=\"$(objpfx)\"

ifeq ($(have-thread-library),yes)
ifeq (yes,$(build-shared))
$(addprefix $(objpfx),$(multithread-test-srcs)): $(shared-thread-library)
else
$(addprefix $(objpfx),$(multithread-test-srcs)): $(static-thread-library)
endif
ifeq (yes,$(build-bounded))
$(multithread-test-srcs:%=$(objpfx)%-bp): $(bounded-thread-library)
endif
endif

$(objpfx)tst-translit.out: $(objpfx)tst-gettext.out
$(objpfx)tst-gettext2.out: $(objpfx)tst-gettext.out
$(objpfx)tst-codeset.out: $(objpfx)tst-gettext.out
$(objpfx)tst-gettext3.out: $(objpfx)tst-gettext.out
$(objpfx)tst-gettext4.out: $(objpfx)tst-gettext.out
$(objpfx)tst-gettext5.out: $(objpfx)tst-gettext.out
$(objpfx)tst-gettext6.out: $(objpfx)tst-gettext.out

CPPFLAGS += -D'LOCALEDIR="$(msgcatdir)"' \
	    -D'LOCALE_ALIAS_PATH="$(msgcatdir)"'
BISONFLAGS = --yacc --name-prefix=__gettext --output

$(inst_msgcatdir)/locale.alias: locale.alias $(+force)
	$(do-install)

=== libio/Makefile ===
# Copyright (C) 1995-2004,2006,2007,2008,2009 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Specific makefile for libio.
#
include ../option-groups.mak

subdir	:= libio

headers	:= stdio.h libio.h _G_config.h bits/stdio.h bits/stdio-lock.h \
	   bits/sys_errlist.h bits/stdio2.h bits/stdio-ldbl.h bits/libio-ldbl.h

routines	:=							      \
	filedoalloc iofclose iofdopen iofflush iofgetpos iofgets iofopen      \
	iofopncook iofputs iofread iofsetpos ioftell			      \
	iofwrite iogetdelim iogetline iogets iopadn iopopen ioputs	      \
	ioseekoff ioseekpos iosetbuffer iosetvbuf ioungetc		      \
	iovsprintf iovsscanf						      \
	iofgetpos64 iofopen64 iofsetpos64				      \
	putchar putchar_u						      \
	iofwide								      \
									      \
	clearerr feof ferror fileno fputc freopen fseek getc getchar	      \
	memstream pclose putc putchar rewind setbuf setlinebuf vasprintf      \
	iovdprintf vscanf vsnprintf obprintf fcloseall fseeko ftello	      \
	freopen64 fseeko64 ftello64					      \
									      \
	__fbufsize __freading __fwriting __freadable __fwritable __flbf	      \
	__fpurge __fpending __fsetlocking				      \
									      \
	libc_fatal fmemopen
routines-$(OPTION_POSIX_C_LANG_WIDE_CHAR) +=				      \
	wfiledoalloc							      \
	iowpadn								      \
	swprintf							      \
	vswprintf iovswscanf swscanf wgenops				      \
	wstrops wfileops wmemstream
routines-$(call option-disabled, OPTION_POSIX_C_LANG_WIDE_CHAR) +=	      \
	wdummyfileops
routines-$(OPTION_POSIX_WIDE_CHAR_DEVICE_IO) +=				      \
	fputwc fputwc_u getwc getwc_u getwchar getwchar_u iofgetws iofgetws_u \
	iofputws iofputws_u iogetwline ioungetwc putwc putwc_u		      \
	putwchar putwchar_u fwprintf vwprintf				      \
	wprintf wscanf fwscanf vwscanf					      \
	fwide

tests = test-fmemopen tst-ext tst-ext2				\
	tst-mmap-setvbuf tst-atime tst-eof			\
	tst-freopen bug-ungetc bug-fseek			\
	tst-mmap-eofsync tst-mmap-fflushsync bug-mmap-fflush	\
	tst-mmap2-eofsync tst-mmap-offend bug-fopena+		\
	bug-ungetc2 bug-ungetc3 bug-ungetc4			\
	tst-memstream1 tst-memstream2				\
	bug-memstream1 tst-popen1
tests-$(OPTION_EGLIBC_LOCALE_CODE)				\
     += tst-swscanf tst-fgetws tst-fopenloc tst-setvbuf1	\
	tst-ungetwc1 tst-ungetwc2 bug-ftell bug-ungetwc2	\
	tst-widetext 
tests-$(OPTION_POSIX_WIDE_CHAR_DEVICE_IO)		\
     += bug-rewind bug-rewind2 bug-ungetwc1		\
	bug-wfflush bug-wmemstream1 tst-fopenloc2	\
	tst_getwc					\
	tst_putwc tst_wprintf tst_wprintf2 tst_wscanf tst-fgetwc bug-wsetpos
tests-$(OPTION_POSIX_C_LANG_WIDE_CHAR)			\
     += tst_swprintf tst_swscanf			\
	tst-sscanf					\
	tst-wmemstream1 tst-wmemstream2
test-srcs = test-freopen

all: # Make this the default target; it will be defined in Rules.

include ../Makeconfig

ifeq ($(versioning),yes)
routines += oldiofopen oldiofdopen oldiofclose oldiopopen oldpclose \
	    oldtmpfile oldiofgetpos oldiofgetpos64 oldiofsetpos	    \
	    oldiofsetpos64
endif

ifneq (,$(filter %REENTRANT, $(defines)))
routines += clearerr_u feof_u ferror_u fputc_u getc_u getchar_u		      \
	    iofflush_u putc_u putchar_u peekc iofread_u iofwrite_u iofgets_u  \
	    iofputs_u

CPPFLAGS += -D_IO_MTSAFE_IO
endif

# Support for exception handling.
CFLAGS-fileops.c = $(exceptions)
CFLAGS-fputc.c = $(exceptions)
CFLAGS-fputwc.c = $(exceptions)
CFLAGS-freopen64.c = $(exceptions)
CFLAGS-freopen.c = $(exceptions)
CFLAGS-fseek.c = $(exceptions)
CFLAGS-fseeko64.c = $(exceptions)
CFLAGS-fseeko.c = $(exceptions)
CFLAGS-ftello64.c = $(exceptions)
CFLAGS-ftello.c = $(exceptions)
CFLAGS-fwide.c = $(exceptions)
CFLAGS-genops.c = $(exceptions)
CFLAGS-getc.c = $(exceptions)
CFLAGS-getchar.c = $(exceptions)
CFLAGS-getwc.c = $(exceptions)
CFLAGS-getwchar.c = $(exceptions)
CFLAGS-iofclose.c = $(exceptions)
CFLAGS-iofflush.c = $(exceptions)
CFLAGS-iofgetpos64.c = $(exceptions)
CFLAGS-iofgetpos.c = $(exceptions)
CFLAGS-iofgets.c = $(exceptions)
CFLAGS-iofgetws.c = $(exceptions)
CFLAGS-iofputs.c = $(exceptions)
CFLAGS-iofputws.c = $(exceptions)
CFLAGS-iofread.c = $(exceptions)
CFLAGS-iofsetpos64.c = $(exceptions)
CFLAGS-iofsetpos.c = $(exceptions)
CFLAGS-ioftell.c = $(exceptions)
CFLAGS-iofwrite.c = $(exceptions)
CFLAGS-iogetdelim.c = $(exceptions)
CFLAGS-iogetline.c = $(exceptions)
CFLAGS-iogets.c = $(exceptions)
CFLAGS-iogetwline.c = $(exceptions)
CFLAGS-ioputs.c = $(exceptions)
CFLAGS-ioseekoff.c = $(exceptions)
CFLAGS-ioseekpos.c = $(exceptions)
CFLAGS-iosetbuffer.c = $(exceptions)
CFLAGS-iosetvbuf.c = $(exceptions)
CFLAGS-ioungetc.c = $(exceptions)
CFLAGS-ioungetwc.c = $(exceptions)
CFLAGS-oldfileops.c = $(exceptions)
CFLAGS-oldiofclose.c = $(exceptions)
CFLAGS-oldiofgetpos64.c = $(exceptions)
CFLAGS-oldiofgetpos.c = $(exceptions)
CFLAGS-oldiofsetpos64.c = $(exceptions)
CFLAGS-oldiofsetpos.c = $(exceptions)
CFLAGS-peekc.c = $(exceptions)
CFLAGS-putc.c = $(exceptions)
CFLAGS-putchar.c = $(exceptions)
CFLAGS-putwc.c = $(exceptions)
CFLAGS-putwchar.c = $(exceptions)
CFLAGS-rewind.c = $(exceptions)
CFLAGS-wfileops.c = $(exceptions)
CFLAGS-wgenops.c = $(exceptions)
CFLAGS-oldiofopen.c = $(exceptions)
CFLAGS-iofopen.c = $(exceptions)
CFLAGS-iofopen64.c = $(exceptions)
CFLAGS-oldtmpfile.c = $(exceptions)
# XXX Do we need filedoalloc and wfiledoalloc?  Others?

CFLAGS-tst_putwc.c = -DOBJPFX=\"$(objpfx)\"

tst_wprintf2-ARGS = "Some Text"

tst-widetext-ENV = LOCPATH=$(common-objpfx)localedata LANGUAGE=C
tst-fopenloc-ENV = LOCPATH=$(common-objpfx)localedata \
		   MALLOC_TRACE=$(objpfx)tst-fopenloc.mtrace
tst-fgetws-ENV = LOCPATH=$(common-objpfx)localedata
tst-ungetwc1-ENV = LOCPATH=$(common-objpfx)localedata
tst-ungetwc2-ENV = LOCPATH=$(common-objpfx)localedata
bug-ungetwc2-ENV = LOCPATH=$(common-objpfx)localedata
tst-swscanf-ENV = LOCPATH=$(common-objpfx)localedata
bug-ftell-ENV = LOCPATH=$(common-objpfx)localedata
tst-fgetwc-ENV = LOCPATH=$(common-objpfx)localedata

generated = tst-fopenloc.mtrace tst-fopenloc.check

aux	:= fileops genops stdfiles stdio strops

ifeq ($(versioning),yes)
aux	+= oldfileops oldstdfiles
endif

shared-only-routines = oldiofopen oldiofdopen oldiofclose oldfileops	\
		       oldstdfiles oldiopopen oldpclose oldtmpfile	\
		       oldiofgetpos oldiofgetpos64 oldiofsetpos		\
		       oldiofsetpos64

distribute := iolibio.h libioP.h strfile.h Banner test-freopen.sh \
	      fd_to_filename.h

include ../Rules

ifeq (y,$(OPTION_POSIX_WIDE_CHAR_DEVICE_IO))
tests: $(objpfx)test-freopen.out
$(objpfx)test-freopen.out: test-freopen.sh $(objpfx)test-freopen
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)'	\
	$(common-objpfx)libio/
endif

ifeq (y,$(OPTION_EGLIBC_LOCALE_CODE))
tests: $(objpfx)tst-fopenloc.check
$(objpfx)tst-fopenloc.check: $(objpfx)tst-fopenloc.out
	cmp ../iconvdata/testdata/ISO-8859-1..UTF8 $(objpfx)tst-fopenloc.out \
	  > $@
	$(common-objpfx)malloc/mtrace $(objpfx)tst-fopenloc.mtrace >> $@
endif

=== locale/Makefile ===
# Copyright (C) 1991,1992,1995-2003,2005,2009 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Makefile for locales.
#
include ../option-groups.mak

subdir	:= locale

headers		= locale.h bits/locale.h langinfo.h xlocale.h
distribute	= localeinfo.h categories.def iso-639.def iso-3166.def \
		  iso-4217.def weight.h weightwc.h strlen-hash.h elem-hash.h \
		  indigits.h indigitswc.h outdigits.h outdigitswc.h \
		  coll-lookup.h C-translit.h.in C-translit.h gen-translit.pl \
		  locarchive.h hashval.h dummy-setlocale.c \
		  $(addprefix programs/, \
			      locale.c localedef.c \
			      $(localedef-modules:=.c) $(locale-modules:=.c) \
			      $(lib-modules:=.c) config.h simple-hash.h \
			      charmap-kw.gperf charmap-kw.h locfile-token.h \
			      locfile-kw.gperf locfile-kw.h linereader.h \
			      locfile.h charmap.h repertoire.h localedef.h \
			      3level.h charmap-dir.h locarchive.c)
# catnames is needed by OPTION_EGLIBC_LOCALE_CODE and by the 'intl' code.
# If we put the latter in an option group, too, we can omit catnames
# when both option groups are disabled.  libstdc++-v3 needs mb_cur_max.
routines-y      := catnames mb_cur_max
routines-$(OPTION_EGLIBC_LOCALE_CODE) \
		+= setlocale findlocale loadlocale loadarchive \
		   localeconv nl_langinfo nl_langinfo_l \
		   newlocale duplocale freelocale uselocale
ifneq (y,$(OPTION_EGLIBC_LOCALE_CODE))
routines-y	+= dummy-setlocale
endif
tests-$(OPTION_EGLIBC_LOCALE_CODE) += tst-C-locale tst-locname tst-duplocale
categories	= ctype messages monetary numeric time paper name \
		  address telephone measurement identification collate
# C-messages belongs in an intl option group.
aux-y		:= C-ctype C-time \
		   SYS_libc C_name xlocale global-locale coll-lookup
aux-$(OPTION_EGLIBC_LOCALE_CODE) \
		+= $(filter-out $(aux-y), \
	                        $(categories:%=lc-%) $(categories:%=C-%)) \
	           localename
others-$(OPTION_EGLIBC_LOCALE_CODE) = localedef locale
#others-static	= localedef locale
install-bin	= $(others-y)
extra-objs-$(OPTION_EGLIBC_LOCALE_CODE) \
		= $(localedef-modules:=.o) $(localedef-aux:=.o) \
		  $(locale-modules:=.o) $(lib-modules:=.o)

extra-libs-$(OPTION_EGLIBC_LOCALE_CODE) = libBrokenLocale
extra-libs-others = $(extra-libs-y)

libBrokenLocale-routines = broken_cur_max

subdir-dirs	= programs
vpath %.c programs ../crypt
vpath %.h programs
vpath %.gperf programs

localedef-modules	:= $(categories:%=ld-%) charmap linereader locfile \
			   repertoire locarchive
localedef-aux		:= md5
locale-modules		:= locale-spec
lib-modules		:= charmap-dir simple-hash xmalloc xstrdup


GPERF = gperf
GPERFFLAGS = -acCgopt -k1,2,5,9,$$ -L ANSI-C

include ../Rules

programs/%-kw.h: programs/%-kw.gperf
	cd programs \
	&& $(GPERF) $(GPERFFLAGS) -N $(@F:-kw.h=_hash) $(<F) > $(@F).new
	mv -f $@.new $@

$(objpfx)localedef: $(localedef-modules:%=$(objpfx)%.o)
$(objpfx)localedef: $(localedef-aux:%=$(objpfx)%.o)
$(objpfx)locale: $(locale-modules:%=$(objpfx)%.o)
$(objpfx)localedef $(objpfx)locale: $(lib-modules:%=$(objpfx)%.o)

C-translit.h: C-translit.h.in gen-translit.pl
	$(PERL) gen-translit.pl < $< > $@.tmp
	mv -f $@.tmp $@
ifeq ($(with-cvs),yes)
	test ! -d CVS || cvs $(CVSOPTS) commit -mRegenerated $@
endif

localepath = "$(localedir):$(i18ndir)"

locale-CPPFLAGS := -DLOCALE_PATH='$(localepath)' \
		   -DLOCALEDIR='"$(localedir)"' \
		   -DLOCALE_ALIAS_PATH='"$(msgcatdir)"' \
		   -DCHARMAP_PATH='"$(i18ndir)/charmaps"' \
		   -DREPERTOIREMAP_PATH='"$(i18ndir)/repertoiremaps"' \
		   -DLOCSRCDIR='"$(i18ndir)/locales"' -DHAVE_CONFIG_H \
		   -Iprograms

CFLAGS-charmap.c = -Wno-write-strings -Wno-char-subscripts
CFLAGS-locfile.c = -Wno-write-strings -Wno-char-subscripts
CFLAGS-charmap-dir.c = -Wno-write-strings
ifneq (y,$(OPTION_EGLIBC_SPAWN))
CFLAGS-charmap-dir.c += -DNO_UNCOMPRESS
endif

# This makes sure -DNOT_IN_libc is passed for all these modules.
cpp-srcs-left := $(addsuffix .c,$(localedef-modules) $(localedef-aux) \
				$(locale-modules) $(lib-modules))
lib := nonlib
include $(patsubst %,$(..)cppflags-iterator.mk,$(cpp-srcs-left))

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(objpfx)libBrokenLocale.so: $(common-objpfx)libc.so \
			     $(common-objpfx)libc_nonshared.a

=== localedata/Makefile ===
# Copyright (C) 1996-2003,2005,2007,2008,2009 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

# Makefile for installing locale data source files.

subdir := localedata

all: # Make this the default target; it will be defined in Rules.

include ../option-groups.mak

# List with all available character set descriptions.
all-charmaps := $(filter-out $(addprefix charmaps/, CVS RCS SCCS %~), \
					 $(wildcard charmaps/[A-I]*) \
					 $(wildcard charmaps/[J-Z]*))

# List with all available character set descriptions.
all-locales := $(filter-out $(addprefix locales/, CVS RCS SCCS %~), \
			    $(wildcard locales/*))

# If the EGLIBC_LOCALES option group is not enabled, trim the
# list of charmap and locale source files.
ifeq ($(OPTION_EGLIBC_LOCALES),y)
charmaps := $(all-charmaps)
locales  := $(all-locales)
else
charmaps := 
locales  := locales/POSIX
endif

subdir-dirs = tests-mbwc
vpath %.c tests-mbwc
vpath %.h tests-mbwc


test-srcs := collate-test xfrm-test tst-fmon tst-rpmatch tst-trans \
	     tst-mbswcs1 tst-mbswcs2 tst-mbswcs3 tst-mbswcs4 tst-mbswcs5 \
	     tst-ctype tst-wctype tst-langinfo tst-numeric
test-input := de_DE.ISO-8859-1 en_US.ISO-8859-1 da_DK.ISO-8859-1 \
	      hr_HR.ISO-8859-2 sv_SE.ISO-8859-1 tr_TR.UTF-8 fr_FR.UTF-8 \
	      si_LK.UTF-8
test-input-data = $(addsuffix .in, $(basename $(test-input)))
test-output := $(foreach s, .out .xout, \
			 $(addsuffix $s, $(basename $(test-input))))
ld-test-names := test1 test2 test3 test4 test5 test6 test7
ld-test-srcs := $(addprefix tests/,$(addsuffix .cm,$(ld-test-names)) \
				   $(addsuffix .def,$(ld-test-names)) \
				   $(addsuffix .ds,test5 test6) \
				   test6.c trans.def)

fmon-tests = n01y12 n02n40 n10y31 n11y41 n12y11 n20n32 n30y20 n41n00 \
	     y01y10 y02n22 y22n42 y30y21 y32n31 y40y00 y42n21

generated := $(test-input) $(test-output) sort-test.out tst-locale.out \
	     tst-mbswcs.out tst-leaks.mtrace mtrace-tst-leaks
generated-dirs := $(ld-test-names) tt_TT de_DE.437			\
		  $(addprefix tstfmon_,$(fmon-tests))			\

distribute := CHECKSUMS README SUPPORTED ChangeLog			\
	      $(all-charmaps) $(all-locales)				\
	      tst-rpmatch.sh tst-locale.sh tst-fmon.sh sort-test.sh	\
	      tst-fmon.data $(test-input-data) $(ld-test-srcs)		\
	      th_TH.in cs_CZ.in tst-mbswcs.sh tst-trans.sh tst-ctype.sh \
	      tst-ctype-de_DE.ISO-8859-1.in				\
	      tst-numeric.sh tst-numeric.data				\
	      $(wildcard tests-mbwc/*.[ch])				\
	      $(addprefix tst-fmon-locales/tstfmon_,$(fmon-tests))	\
	      gen-locale.sh show-ucs-data.c tst-langinfo.sh		\
	      tst-wctype.sh tst-wctype.input gen-unicode-ctype.c	\
	      dump-ctype.c

# Get $(inst_i18ndir) defined.
include ../Makeconfig

# eglibc: ifeq (no,$(cross-compiling))
locale_test_suite := tst_iswalnum tst_iswalpha tst_iswcntrl            \
		     tst_iswctype tst_iswdigit tst_iswgraph            \
		     tst_iswlower tst_iswprint tst_iswpunct            \
		     tst_iswspace tst_iswupper tst_iswxdigit tst_mblen \
		     tst_mbrlen tst_mbrtowc tst_mbsrtowcs tst_mbstowcs \
		     tst_mbtowc tst_strcoll tst_strfmon tst_strxfrm    \
		     tst_swscanf tst_towctrans tst_towlower            \
		     tst_towupper tst_wcrtomb tst_wcscat tst_wcschr    \
		     tst_wcscmp tst_wcscoll tst_wcscpy tst_wcscspn     \
		     tst_wcslen tst_wcsncat tst_wcsncmp tst_wcsncpy    \
		     tst_wcspbrk tst_wcsrtombs tst_wcsspn tst_wcsstr   \
		     tst_wcstod tst_wcstok tst_wcstombs tst_wcswidth   \
		     tst_wcsxfrm tst_wctob tst_wctomb tst_wctrans      \
		     tst_wctype tst_wcwidth

# Since these tests build their own locale files, they're not
# dependent on the OPTION_EGLIBC_LOCALES option group.  But they do
# need the locale functions to be present.
tests-$(OPTION_EGLIBC_LOCALE_CODE) \
     += $(locale_test_suite) tst-digits tst-setlocale bug-iconv-trans \
	tst-leaks tst-mbswcs6 tst-xlocale1 tst-xlocale2 bug-usesetlocale \
	tst-strfmon1 tst-sscanf tst-strptime
ifeq (yesy,$(build-shared)$(OPTION_EGLIBC_LOCALE_CODE))
ifneq (no,$(PERL))
tests: $(objpfx)mtrace-tst-leaks
endif
endif
# eglibc: endif

# Files to install.
install-others := $(addprefix $(inst_i18ndir)/, \
			      $(addsuffix .gz, $(charmaps)) \
			      $(locales))

tests: $(objdir)/iconvdata/gconv-modules

include ../Rules

# Install the charmap files in gzipped format.
$(inst_i18ndir)/charmaps/%.gz: charmaps/% $(+force)
	$(make-target-directory)
	rm -f $(@:.gz=) $@
	$(INSTALL_DATA) $< $(@:.gz=)
	gzip -9n $(@:.gz=)

# Install the locale source files in the appropriate directory.
$(inst_i18ndir)/locales/%: locales/% $(+force); $(do-install)

# gcc does not know all the format specifiers we are using here.
CFLAGS-tst-mbswcs1.c = -Wno-format
CFLAGS-tst-mbswcs2.c = -Wno-format
CFLAGS-tst-mbswcs3.c = -Wno-format
CFLAGS-tst-mbswcs4.c = -Wno-format
CFLAGS-tst-mbswcs5.c = -Wno-format
CFLAGS-tst-trans.c = -Wno-format


# eglibc: ifeq (no,$(cross-compiling))
# We have to generate locales
LOCALES := de_DE.ISO-8859-1 de_DE.UTF-8 en_US.ANSI_X3.4-1968 \
	   en_US.ISO-8859-1 en_US.UTF-8 ja_JP.EUC-JP da_DK.ISO-8859-1 \
	   hr_HR.ISO-8859-2 sv_SE.ISO-8859-1 ja_JP.SJIS fr_FR.ISO-8859-1 \
	   vi_VN.TCVN5712-1 nb_NO.ISO-8859-1 nn_NO.ISO-8859-1 \
	   tr_TR.UTF-8 cs_CZ.UTF-8 zh_TW.EUC-TW fa_IR.UTF-8 fr_FR.UTF-8 \
	   ja_JP.UTF-8 si_LK.UTF-8
LOCALE_SRCS := $(shell echo "$(LOCALES)"|sed 's/\([^ .]*\)[^ ]*/\1/g')
CHARMAPS := $(shell echo "$(LOCALES)" | \
		    sed -e 's/[^ .]*[.]\([^ ]*\)/\1/g' -e s/SJIS/SHIFT_JIS/g)
CTYPE_FILES = $(addsuffix /LC_CTYPE,$(LOCALES))

generated-dirs += $(LOCALES)

# Dependency for the locale files.  We actually make it depend only on
# one of the files.
$(addprefix $(objpfx),$(CTYPE_FILES)): %: \
  gen-locale.sh $(common-objpfx)locale/localedef Makefile \
  $(addprefix charmaps/,$(CHARMAPS)) $(addprefix locales/,$(LOCALE_SRCS))
	@$(SHELL) -e gen-locale.sh $(common-objpfx)	\
		 '$(if $(cross-localedef), 		\
		       $(cross-localedef),		\
		       $(built-program-cmd))'		\
		 $@

$(addsuffix .out,$(addprefix $(objpfx),$(tests))): %: \
  $(addprefix $(objpfx),$(CTYPE_FILES))

ifeq (y,$(OPTION_EGLIBC_LOCALE_CODE))
tests: $(objpfx)sort-test.out $(objpfx)tst-fmon.out $(objpfx)tst-locale.out \
       $(objpfx)tst-rpmatch.out $(objpfx)tst-trans.out \
       $(objpfx)tst-mbswcs.out $(objpfx)tst-ctype.out \
       $(objpfx)tst-langinfo.out $(objpfx)tst-numeric.out
ifeq (y,$(OPTION_POSIX_WIDE_CHAR_DEVICE_IO))
tests: $(objpfx)tst-wctype.out
endif
endif

$(objpfx)sort-test.out: sort-test.sh $(objpfx)collate-test $(objpfx)xfrm-test \
		       $(test-input-data) $(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)' $(test-input) \
	  > $@
$(objpfx)tst-fmon.out: tst-fmon.sh $(objpfx)tst-fmon tst-fmon.data \
		       $(objpfx)sort-test.out \
		       $(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)' tst-fmon.data \
	  > $@
$(objpfx)tst-numeric.out: tst-numeric.sh $(objpfx)tst-numeric tst-numeric.data \
		       $(objpfx)sort-test.out \
		       $(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)' tst-numeric.data \
	  > $@
$(objpfx)tst-locale.out: tst-locale.sh $(common-objpfx)locale/localedef \
			 $(ld-test-srcs) $(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(built-program-cmd)' > $@
$(objpfx)tst-rpmatch.out: tst-rpmatch.sh $(objpfx)tst-rpmatch \
			  $(objpfx)tst-fmon.out \
			  $(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(built-program-cmd)' > $@
$(objpfx)tst-trans.out: tst-trans.sh $(objpfx)tst-trans \
			$(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)'
$(objpfx)tst-mbswcs.out: tst-mbswcs.sh $(objpfx)tst-mbswcs1 \
			 $(objpfx)tst-mbswcs2 $(objpfx)tst-mbswcs3 \
			 $(objpfx)tst-mbswcs4 $(objpfx)tst-mbswcs5 \
			 $(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(run-program-prefix)'
$(objpfx)tst-ctype.out: tst-ctype.sh $(objpfx)tst-ctype \
			$(objpfx)sort-test.out \
			$(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(built-program-cmd)'
$(objpfx)tst-wctype.out: tst-wctype.sh $(objpfx)tst-wctype \
			$(objpfx)sort-test.out tst-wctype.input \
			$(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(built-program-cmd)'
$(objpfx)tst-langinfo.out: tst-langinfo.sh $(objpfx)tst-langinfo \
			$(objpfx)sort-test.out \
			$(addprefix $(objpfx),$(CTYPE_FILES))
	$(SHELL) -e $< $(common-objpfx) '$(built-program-cmd)'
$(objpfx)tst-digits.out: $(objpfx)tst-locale.out
$(objpfx)tst-mbswcs6.out: $(addprefix $(objpfx),$(CTYPE_FILES))
# eglibc: endif

include SUPPORTED

# Only install locale data if OPTION_EGLIBC_LOCALES is selected.
ifneq ($(OPTION_EGLIBC_LOCALES),y)
SUPPORTED-LOCALES :=
endif

INSTALL-SUPPORTED-LOCALES=$(addprefix install-, $(SUPPORTED-LOCALES))

# Sometimes the whole collection of locale files should be installed.
LOCALEDEF=I18NPATH=. GCONV_PATH=$(common-objpfx)iconvdata LC_ALL=C \
$(common-objpfx)elf/ld.so --library-path $(rpath-link) $(common-objpfx)locale/localedef
install-locales: $(INSTALL-SUPPORTED-LOCALES)

install-locales-dir:
	$(..)./scripts/mkinstalldirs $(inst_localedir)

$(INSTALL-SUPPORTED-LOCALES): install-locales-dir
	@locale=`echo $@ | sed -e 's/^install-//'`; \
	charset=`echo $$locale | sed -e 's,.*/,,'`; \
	locale=`echo $$locale | sed -e 's,/[^/]*,,'`; \
	echo -n `echo $$locale | sed 's/\([^.\@]*\).*/\1/'`; \
	echo -n ".$$charset"; \
	echo -n `echo $$locale | sed 's/\([^\@]*\)\(\@.*\)*/\2/'`; \
	echo -n '...'; \
	input=`echo $$locale | sed 's/\([^.]*\)[^@]*\(.*\)/\1\2/'`; \
	$(LOCALEDEF) --alias-file=../intl/locale.alias \
		     -i locales/$$input -c -f charmaps/$$charset \
		     $(addprefix --prefix=,$(install_root)) $$locale; \
	echo ' done'; \

# The mbwc-tests need some environment setup to find the locale data files
TEST_MBWC_ENV:= LOCPATH=$(common-objpfx)localedata
tst_iswalnum-ENV = $(TEST_MBWC_ENV)
tst_iswalpha-ENV = $(TEST_MBWC_ENV)
tst_iswcntrl-ENV = $(TEST_MBWC_ENV)
tst_iswctype-ENV = $(TEST_MBWC_ENV)
tst_iswdigit-ENV = $(TEST_MBWC_ENV)
tst_iswgraph-ENV = $(TEST_MBWC_ENV)
tst_iswlower-ENV = $(TEST_MBWC_ENV)
tst_iswprint-ENV = $(TEST_MBWC_ENV)
tst_iswpunct-ENV = $(TEST_MBWC_ENV)
tst_iswspace-ENV = $(TEST_MBWC_ENV)
tst_iswupper-ENV = $(TEST_MBWC_ENV)
tst_iswxdigit-ENV = $(TEST_MBWC_ENV)
tst_mblen-ENV = $(TEST_MBWC_ENV)
tst_mbrlen-ENV = $(TEST_MBWC_ENV)
tst_mbrtowc-ENV = $(TEST_MBWC_ENV)
tst_mbsrtowcs-ENV = $(TEST_MBWC_ENV)
tst_mbstowcs-ENV = $(TEST_MBWC_ENV)
tst_mbtowc-ENV = $(TEST_MBWC_ENV)
tst_strcoll-ENV = $(TEST_MBWC_ENV)
tst_strfmon-ENV = $(TEST_MBWC_ENV)
tst_strxfrm-ENV = $(TEST_MBWC_ENV)
tst_swscanf-ENV = $(TEST_MBWC_ENV)
tst_towctrans-ENV = $(TEST_MBWC_ENV)
tst_towlower-ENV = $(TEST_MBWC_ENV)
tst_towupper-ENV = $(TEST_MBWC_ENV)
tst_wcrtomb-ENV = $(TEST_MBWC_ENV)
tst_wcscat-ENV = $(TEST_MBWC_ENV)
tst_wcschr-ENV = $(TEST_MBWC_ENV)
tst_wcscmp-ENV = $(TEST_MBWC_ENV)
tst_wcscoll-ENV = $(TEST_MBWC_ENV)
tst_wcscpy-ENV = $(TEST_MBWC_ENV)
tst_wcscspn-ENV = $(TEST_MBWC_ENV)
tst_wcslen-ENV = $(TEST_MBWC_ENV)
tst_wcsncat-ENV = $(TEST_MBWC_ENV)
tst_wcsncmp-ENV = $(TEST_MBWC_ENV)
tst_wcsncpy-ENV = $(TEST_MBWC_ENV)
tst_wcspbrk-ENV = $(TEST_MBWC_ENV)

=== login/Makefile ===
# Copyright (C) 1996-1998,2000-2003,2007, 2009 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Sub-makefile for login portion of the library.
#
include ../option-groups.mak

subdir	:= login

headers	:= utmp.h bits/utmp.h lastlog.h pty.h

routines := getpt grantpt unlockpt ptsname
routines-$(OPTION_EGLIBC_UTMP) \
	 += getutent getutent_r getutid getutline getutid_r getutline_r \
	    utmp_file utmpname updwtmp

CFLAGS-grantpt.c = -DLIBEXECDIR='"$(libexecdir)"'

others = pt_chown
others-$(OPTION_EGLIBC_UTMP) += utmpdump
install-others-programs = $(inst_libexecdir)/pt_chown

distribute := utmp-private.h utmp-equal.h pty-private.h

subdir-dirs = programs
vpath %.c programs

tests := tst-utmp tst-utmpx tst-grantpt

# Build the -lutil library with these extra functions.
extra-libs-$(OPTION_EGLIBC_UTMP) := libutil
extra-libs-others := $(extra-libs-y)

libutil-routines:= login login_tty logout logwtmp openpty forkpty

include ../Rules

CFLAGS-getpt.c = -fexceptions

ifeq (yes,$(build-static-nss))
otherlibs += $(nssobjdir)/libnss_files.a $(resolvobjdir)/libnss_dns.a \
	     $(resolvobjdir)/libresolv.a $(common-objpfx)libc.a
endif

ifeq (yesyes,$(have-fpie)$(build-shared))
pt_chown-cflags += $(pie-ccflag)
endif
ifeq (yes,$(have-ssp))
pt_chown-cflags += -fstack-protector
endif
ifeq (yes,$(have-libcap))
libcap = -lcap
endif
CFLAGS-pt_chown.c = $(pt_chown-cflags)
LDLIBS-pt_chown = $(libcap)
ifeq (yesyes,$(have-fpie)$(build-shared))
LDFLAGS-pt_chown = -Wl,-z,now

$(objpfx)pt_chown: $(objpfx)pt_chown.o
	$(+link-pie)
endif

# pt_chown needs to be setuid root.
$(inst_libexecdir)/pt_chown: $(objpfx)pt_chown $(+force)
	$(make-target-directory)
	-$(INSTALL_PROGRAM) -m 4755 -o root $< $@

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(objpfx)libutil.so: $(common-objpfx)libc.so $(common-objpfx)libc_nonshared.a

=== math/Makefile ===
# Copyright (C) 1996-2001,2002,2003,2004,2005,2006
#	Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

# Makefile for the math library.

subdir		:= math

include ../option-groups.mak

# Installed header files.
headers		:= math.h bits/mathcalls.h bits/mathinline.h bits/huge_val.h \
		   bits/huge_valf.h bits/huge_vall.h bits/inf.h bits/nan.h \
		   fpu_control.h complex.h bits/cmathcalls.h fenv.h \
		   bits/fenv.h bits/fenvinline.h bits/mathdef.h tgmath.h

# Internal header files.
distribute	:= math_ldbl.h math_private.h machine/asm.h

# FPU support code.
aux		:= setfpucw fpu_control

# Build the -lm library.

extra-libs-$(OPTION_EGLIBC_LIBM) := libm
extra-libs-others-$(OPTION_EGLIBC_LIBM) = $(extra-libs-$(OPTION_EGLIBC_LIBM))

libm-support = k_standard s_lib_version s_matherr s_signgam		\
	       fclrexcpt fgetexcptflg fraiseexcpt fsetexcptflg		\
	       ftestexcept fegetround fesetround fegetenv feholdexcpt	\
	       fesetenv feupdateenv t_exp fedisblxcpt feenablxcpt	\
	       fegetexcept
libm-calls = e_acos e_acosh e_asin e_atan2 e_atanh e_cosh e_exp e_fmod	\
	     e_hypot e_j0 e_j1 e_jn e_lgamma_r e_log e_log10 e_pow	\
	     e_rem_pio2 e_remainder e_scalb e_sinh e_sqrt e_gamma_r	\
	     k_cos k_rem_pio2 k_sin k_tan s_asinh s_atan s_cbrt		\
	     s_ceil s_cos s_erf s_expm1 s_fabs				\
	     s_floor s_ilogb s_log1p s_logb				\
	     s_nextafter s_nexttoward s_rint s_scalbln			\
	     s_significand s_sin s_tan s_tanh w_acos w_acosh w_asin	\
	     w_atan2 w_atanh w_cosh w_drem w_exp w_exp2 w_exp10 w_fmod	\
	     w_tgamma w_hypot w_j0 w_j1 w_jn w_lgamma w_lgamma_r	\
	     w_log w_log10 w_pow w_remainder w_scalb w_sinh w_sqrt	\
	     s_fpclassify s_fmax s_fmin s_fdim s_nan s_trunc		\
	     s_remquo e_log2 e_exp2 s_round s_nearbyint s_sincos	\
	     conj cimag creal cabs carg s_cexp s_csinh s_ccosh s_clog	\
	     s_catan s_casin s_ccos s_csin s_ctan s_ctanh s_cacos	\
	     s_casinh s_cacosh s_catanh s_csqrt s_cpow s_cproj s_clog10 \
	     s_fma s_lrint s_llrint s_lround s_llround e_exp10 w_log2	\
	     $(calls:s_%=m_%)

include ../Makeconfig

dbl-only-routines := branred doasin dosincos halfulp mpa mpatan2	\
		     mpatan mpexp mplog mpsqrt mptan sincos32 slowexp	\
		     slowpow
libm-routines = $(strip $(libm-support) $(libm-calls) \
			$(patsubst %_rf,%f_r,$(libm-calls:=f))	\
			$(long-m-$(long-double-fcts))) \
		$(dbl-only-routines)
long-m-routines = $(patsubst %_rl,%l_r,$(libm-calls:=l))
long-m-support = t_sincosl k_sincosl
long-m-yes = $(long-m-routines) $(long-m-support)

# These functions are in libc instead of libm because __printf_fp
# calls them, so any program using printf will need them linked in,
# and we don't want to have to link every program with -lm.
# In libm-calls (above), list m_foo in place of s_foo for any
# routine that should be compiled separately for its libc and libm versions.
calls = s_isinf s_isnan s_finite s_copysign s_modf s_scalbn s_frexp s_ldexp \
	s_signbit
generated += $(foreach s,.c .S l.c l.S f.c f.S,$(calls:s_%=m_%$s))
routines = $(calls) $(calls:=f) $(long-c-$(long-double-fcts))
long-c-yes = $(calls:=l)
distribute += $(filter-out $(generated),$(long-m-yes:=.c) $(long-c-yes:=.c))

# Rules for the test suite.
tests = test-matherr test-fenv atest-exp atest-sincos atest-exp2 basic-test \
	test-misc test-fpucw tst-definitions test-tgmath test-tgmath-ret \
	bug-nextafter bug-nexttoward bug-tgmath1 test-tgmath-int test-tgmath2
# We do the `long double' tests only if this data type is available and
# distinct from `double'.
test-longdouble-yes = test-ldouble test-ildoubl
distribute += $(test-longdouble-yes:=.c)

ifneq (no,$(PERL))
libm-tests = test-float test-double $(test-longdouble-$(long-double-fcts)) \
	test-ifloat test-idouble
libm-tests.o = $(addsuffix .o,$(libm-tests))

tests += $(libm-tests)
libm-tests-generated = libm-test-ulps.h libm-test.c
generated += $(libm-tests-generated) libm-test.stmp

# This is needed for dependencies
before-compile += $(objpfx)libm-test.c

ulps-file = $(firstword $(wildcard $(sysdirs:%=%/libm-test-ulps)))

$(addprefix $(objpfx), $(libm-tests-generated)): $(objpfx)libm-test.stmp

$(objpfx)libm-test.stmp: $(ulps-file) libm-test.inc gen-libm-test.pl
	$(make-target-directory)
	$(PERL) gen-libm-test.pl -u $< -o "$(objpfx)"
	@echo > $@

$(objpfx)test-float.o: $(objpfx)libm-test.stmp
$(objpfx)test-ifloat.o: $(objpfx)libm-test.stmp
$(objpfx)test-double.o: $(objpfx)libm-test.stmp
$(objpfx)test-idouble.o: $(objpfx)libm-test.stmp
$(objpfx)test-ldouble.o: $(objpfx)libm-test.stmp
$(objpfx)test-ildoubl.o: $(objpfx)libm-test.stmp
endif

CFLAGS-test-float.c = -fno-inline -ffloat-store -fno-builtin
CFLAGS-test-double.c = -fno-inline -ffloat-store -fno-builtin
CFLAGS-test-ldouble.c = -fno-inline -ffloat-store -fno-builtin
CFLAGS-test-tgmath.c = -fno-builtin
CFLAGS-test-tgmath2.c = -fno-builtin
CFLAGS-test-tgmath-ret.c = -fno-builtin
CPPFLAGS-test-ifloat.c = -U__LIBC_INTERNAL_MATH_INLINES -D__FAST_MATH__ \
			 -DTEST_FAST_MATH -fno-builtin
CPPFLAGS-test-idouble.c = -U__LIBC_INTERNAL_MATH_INLINES -D__FAST_MATH__ \
			 -DTEST_FAST_MATH -fno-builtin
CPPFLAGS-test-ildoubl.c = -U__LIBC_INTERNAL_MATH_INLINES -D__FAST_MATH__ \
			  -DTEST_FAST_MATH -fno-builtin

distribute += libm-test.inc gen-libm-test.pl README.libm-test


# The -lieee module sets the _LIB_VERSION_ switch to IEEE mode
# for error handling in the -lm functions.
install-lib += libieee.a
non-lib.a += libieee.a
extra-objs += libieee.a ieee-math.o
distribute += ieee-math.c

include ../Rules


# The generated sysd-rules file defines rules like this for sources
# coming from sysdeps/ directories.  These rules find the generic sources.
define o-iterator-doit
$(objpfx)m_%$o: s_%.c $(before-compile); $$(compile-command.c)
endef
object-suffixes-left := $(all-object-suffixes)
include $(o-iterator)


# This file defines the default _LIB_VERSION variable that controls
# the error return conventions for the math functions.
CPPFLAGS-s_lib_version.c := -D_POSIX_MODE

# We don't want the fdlibm code to use the inline math functions,
# only the fdlibm code.
math-CPPFLAGS += -D__NO_MATH_INLINES -D__LIBC_INTERNAL_MATH_INLINES

ifneq ($(long-double-fcts),yes)
# The `double' and `long double' types are the same on this machine.
# We won't compile the `long double' code at all.  Tell the `double' code
# to define aliases for the `FUNCl' names.  To avoid type conflicts in
# defining those aliases, tell <math.h> to declare the `FUNCl' names with
# `double' instead of `long double'.
math-CPPFLAGS += -DNO_LONG_DOUBLE -D_Mlong_double_=double
endif

# The fdlibm code generates a lot of these warnings but is otherwise clean.
override CFLAGS += -Wno-uninitialized

# The -lieee library is actually an object file.
# The module just defines the _LIB_VERSION_ variable.
# It's not a library to make sure it is linked in instead of s_lib_version.o.
$(objpfx)libieee.a: $(objpfx)ieee-math.o
	rm -f $@
	$(patsubst %/,cd % &&,$(objpfx)) \
	$(LN_S) $(<F) $(@F)

ifeq ($(build-shared),yes)
$(addprefix $(objpfx),$(tests)): $(objpfx)libm.so$(libm.so-version)
else
$(addprefix $(objpfx),$(tests)): $(objpfx)libm.a
endif
ifeq ($(build-bounded),yes)
$(tests:%=$(objpfx)%-bp): $(objpfx)libm_b.a
endif

ifeq ($(build-static),yes)
o = .o
else
o = .os
endif
gmp-objs = $(patsubst %,$(common-objpfx)stdlib/%$o,\
		      add_n sub_n cmp addmul_1 mul_1 mul_n divmod_1 \
		      lshift rshift mp_clz_tab udiv_qrnnd inlines)
$(objpfx)atest-exp: $(gmp-objs)
$(objpfx)atest-sincos: $(gmp-objs)
$(objpfx)atest-exp2: $(gmp-objs)

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(objpfx)libm.so: $(common-objpfx)libc.so $(common-objpfx)libc_nonshared.a

=== nis/Makefile ===
# Copyright (C) 1996,1997,1998,2001,2004,2006 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
# 02111-1307 USA.

#
#	Makefile for NIS/NIS+ part.
#
include ../option-groups.mak

subdir	:= nis

aux			:= nis_hash

headers			:= $(wildcard rpcsvc/*.[hx])
distribute		:= nss-nis.h nss-nisplus.h nis_intern.h Banner \
			   nisplus-parser.h nis_xdr.h nss

# These are the databases available for the nis (and perhaps later nisplus)
# service.  This must be a superset of the services in nss.
databases-y		:= proto service hosts network grp pwd rpc ethers \
			   spwd netgrp publickey
databases-$(OPTION_EGLIBC_DB_ALIASES) += alias

# Specify rules for the nss_* modules.
# The 'compat' module includes nis support, and the 'nss' directory
# includes a bare-bones "files" library, so we'll include 'compat' in
# OPTION_EGLIBC_NIS.
services-y		:=
services-$(OPTION_EGLIBC_NIS) += nis nisplus compat

extra-libs-$(OPTION_EGLIBC_NIS) += libnsl
extra-libs-y		+= $(services-y:%=libnss_%)

# These libraries will be built in the `others' pass rather than
# the `lib' pass, because they depend on libc.so being built already.
extra-libs-others-y	+= $(extra-libs-y)

# The sources are found in the appropriate subdir.
subdir-dirs = $(services-y:%=nss_%)
vpath %.c $(subdir-dirs)

libnsl-routines = yp_xdr ypclnt ypupdate_xdr \
                  nis_subr nis_local_names nis_free nis_file \
                  nis_print nis_error nis_call nis_lookup\
                  nis_table nis_xdr nis_server nis_ping \
		  nis_checkpoint nis_mkdir nis_rmdir nis_getservlist\
		  nis_verifygroup nis_ismember nis_addmember nis_util\
		  nis_removemember nis_creategroup nis_destroygroup\
		  nis_print_group_entry nis_domain_of nis_domain_of_r\
		  nis_modify nis_remove nis_add nis_defaults\
		  nis_findserv nis_callback nis_clone_dir nis_clone_obj\
		  nis_clone_res nss-default

libnss_compat-routines	:= $(addprefix compat-,grp pwd spwd initgroups)
libnss_compat-inhibit-o	= $(filter-out .os,$(object-suffixes))

libnss_nis-routines	:= $(addprefix nis-,$(databases-y)) nis-initgroups \
			   nss-nis
libnss_nis-inhibit-o	= $(filter-out .os,$(object-suffixes))

libnss_nisplus-routines	:= $(addprefix nisplus-,$(databases-y)) nisplus-parser \
			   nss-nisplus nisplus-initgroups
libnss_nisplus-inhibit-o = $(filter-out .os,$(object-suffixes))

include ../Rules


$(objpfx)libnss_compat.so: $(objpfx)libnsl.so$(libnsl.so-version)
$(objpfx)libnss_nis.so: $(objpfx)libnsl.so$(libnsl.so-version) \
			$(common-objpfx)nss/libnss_files.so
$(objpfx)libnss_nisplus.so: $(objpfx)libnsl.so$(libnsl.so-version)

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(services-y:%=$(objpfx)libnss_%.so) $(objpfx)libnsl.so: \
	$(common-objpfx)libc.so $(common-objpfx)libc_nonshared.a


ifeq ($(build-shared),yes)
$(others-y:%=$(objpfx)%): $(objpfx)libnsl.so$(libnsl.so-version)
else
$(others-y:%=$(objpfx)%): $(objpfx)libnsl.a
endif

=== changelog ===
alsa-lib (1.0.23-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Add refcount-dlobjs.patch: backported upstream patch, originally by
    Jaroslav Kysela, to fix crashes when plugins are unloaded.
    (Closes: #589896, LP: #552411, #584393)
  * Add libtool-out-of-tree.patch: fix libtool version checking for the biarch
    build by grepping ltmain.sh in the ${srcdir}, making it unnecessary to
    force -DUSE_VERSIONED_SYMBOLS for the biarch build

 -- Simon McVittie <smcv@debian.org>  Fri, 08 Oct 2010 08:30:54 +0100

alsa-lib (1.0.23-2) unstable; urgency=medium

  [ Elimar Riesebieter ]
  * Make setlocale() thread safe:
    Applied thread-safe-locale.patch and thread-specific-locale.patch from
    upstream. (Closes: #595252)
  * Bump Standards-Version to 3.9.1, with no changes required.

 -- Jordi Mallach <jordi@debian.org>  Wed, 22 Sep 2010 12:22:18 +0200

alsa-lib (1.0.23-1) unstable; urgency=low

  * New upstream release.

  [ Elimar Riesebieter ]
  * Add powerpcspe to the list of supported architectures. Hint by Sebastian
    Andrzej Siewior. (closes: #583615)
  * Introduced DEP-3 patch headers.
  * Patch Dont_leak_timer_fd_on_pcm_slave_close.patch applied from upstream.
    Removed.

  [ Jordi Mallach ]
  * Remove lpia from the list of supported architectures, as it's not used
    by Ubuntu anymore.

 -- Jordi Mallach <jordi@debian.org>  Wed, 02 Jun 2010 20:21:04 +0200

alsa-lib (1.0.22-2) unstable; urgency=low

  [ Jordi Mallach ]
  * Bump Standards-Version to 3.8.4, with no changes required.

  [ Elimar Riesebieter]
  * Readded -DUSE_VERSIONED_SYMBOLS only to the bibuild CFLAGS.
    (Closes: #570703)

 -- Jordi Mallach <jordi@debian.org>  Sun, 21 Feb 2010 01:03:48 +0100

alsa-lib (1.0.22-1) unstable; urgency=low

  * New upstream release. (Closes: #549531)

  [ Jordi Mallach ]
  * Remove lintian overrides file; it only contains an obsolete entry.

  [ Daniel T Chen ]
  * debian/control: Add sparc64 to Architecture field for libasound2{,-dev}
    using patch from Aurelien Jarno. Thanks! (Closes: #560405)
  * debian/patches/Dont_leak_timer_fd_on_pcm_slave_close.patch: Properly
    free timer fd when closing pcm slaves. Backported from upstream master
    HEAD (LP: #451893) (Closes: #568101)

  [ Elimar Riesebieter]
  * Switched to source version 3.0.
  * As we are defining CFLAGS in rules -D_GNU_SOURCE added as suposed in
    original Makefile.
  * Removed -DUSE_VERSIONED_SYMBOLS from CFLAGS. It is used in the build system
    now.
  * Removed lintian file installation from rules.

 -- Jordi Mallach <jordi@debian.org>  Thu, 11 Feb 2010 21:24:39 +0100

alsa-lib (1.0.21a-1) unstable; urgency=low

  [ Elimar Riesebieter ]
  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Mon, 14 Sep 2009 21:56:13 +0200

alsa-lib (1.0.21-1) unstable; urgency=low

  * New upstream release.
    + libasound2: Division by zero in pcm_rate.c when period_size->min == 0.
      Patch from John Lindgren applied upstream. Thanks! (closes: #539454)

  [ Elimar Riesebieter ]
  * Enable AM_MAINTAINER_MODE in a way where it actually has effect.
    Thanks Lionel Elie Mamane. (closes: #505088)
  * libasound2-dev: Don't install unneeded .la files. Bump shlibs to >> 1.0.20.
  * Added README.sources.
  * Updated changelog.ALSA and patches.

  [ Jordi Mallach ]
  * Revert .la removal after discussion with the Release Team. Instead,
    clear dependency_libs until all the depending packages have dropped the
    reverse dependency.

 -- Jordi Mallach <jordi@debian.org>  Thu, 10 Sep 2009 12:09:48 +0200

alsa-lib (1.0.20-4) unstable; urgency=low

  [ Elimar Riesebieter ]
  * Conflicts: libc6-i386 (<= 2.9-18) to lib32asound2 and lib32asound2-dev as
    suggested by Aurelien Jarno. (closes: #538835)

  [ Jordi Mallach ]
  * Update Standards-Version to 3.8.3. No changes needed.

 -- Jordi Mallach <jordi@debian.org>  Fri, 28 Aug 2009 11:37:38 +0200

alsa-lib (1.0.20-3) unstable; urgency=low

  [ Jordi Mallach ]
  * Build-Depend on python-dev instead of python2.4-dev, as suggested
    by Steve Langasek (closes: #532044).

  [ Elimar Riesebieter ]
  * Move files in /emul/ia32-linux to /usr/lib32 as suggested by Clint Adams.
  * Pre-Depends: libc6-i386 (>= 2.9-18) (closes: #533005)
  * Bumped Standards-Version to 3.8.2. No changes.

 -- Jordi Mallach <jordi@debian.org>  Wed, 24 Jun 2009 13:40:03 +0200

alsa-lib (1.0.20-2) unstable; urgency=medium

  [ Elimar Riesebieter ]
  * Added -DUSE_VERSIONED_SYMBOLS to CFLAGS. This make sure the symbols
    associated to ALSA_0.9.0rc4 and ALSA_0.9.0rc8 are back in lib32asound2.
    (closes: #529940)
  * Removed duplicated 'Section' fields in debian/control.

 -- Jordi Mallach <jordi@debian.org>  Fri, 29 May 2009 01:56:26 +0200

alsa-lib (1.0.20-1) unstable; urgency=low

  * New upstream release.

  [ Elimar Riesebieter ]
  * Added lib(32|64)asound2-plugins to lib(32|64)asond2 suggestions. Thanks Jan
    Muszynski. (closes: #523420)
  * Added avr32 to Architectures. Thanks Bradley Smith for the hint.
    (closes: #528667)
  * Replaced "dh_clean -k" with "dh_prep"
  * Bumped Standard-Version to 3.8.1; no changes needed.
  * All patches refreshed.

 -- Jordi Mallach <jordi@debian.org>  Thu, 21 May 2009 02:34:29 +0200

alsa-lib (1.0.19-1) unstable; urgency=low

  * New upstream release.
  * Upload to unstable.

  [ Elimar Riesebieter ]
  * Install asoundrc.txt as an example. (closes: #505090)
  * Added libcxxtools-dev to Build-Depends

  [ Jordi Mallach ]
  * Change configure calls to use --build instead of --host to correct
    the biarch build for alsa-lib. Thanks to Andreas Metzler and
    Neil Williams for the advice (closes: #516585).

 -- Jordi Mallach <jordi@debian.org>  Wed, 04 Mar 2009 01:44:12 +0100

alsa-lib (1.0.18-1) experimental; urgency=low

  * New upstream release.

  [ Jordi Mallach ]
  * Improve libasound2's short description following suggestions by
    Dan Chen and Barry deFreese. Thanks! (closes: #493512)

  [ Elimar Riesebieter ]


=== debian/changelog ===
ia32-libs-core (20110202) stable; urgency=low

  [ Goswin von Brederlow ]
  * Do not disable secure APT when downloading packages.
  * Add fix for duplicate sources due to security updates.
  * Add security repository next to the regular Debian mirror.
  * Welcome Thijs Kinkhorst to the team.

  * Packages updated

  [ eglibc (2.11.2-10) unstable; urgency=low ]

  * Add patches/amd64/cvs-avx-tcb-alignment.diff from upstream to fix
    alignement issues on CPU supporting the AVX instruction set. 
    #610657.

  [ eglibc (2.11.2-9) unstable; urgency=low ]

  * Disable build failure in case of testsuite regressions, will be
    re-enabled after squeeze release.

  [ eglibc (2.11.2-8) unstable; urgency=low ]

  [ Clint Adams ]
  * Japanese debconf translation update from Nobuhiro Iwamatsu.
    #604752.

  [ Samuel Thibault ]
  * Add expected gettext failure on hurd-i386.

  [ Aurelien Jarno ]
  * Update patches/localedata/locale-et_EE.diff to switch Estonian currency
    to euro. #608803.
  * Revert incorrect upstream patch for CVE-2010-3847 and use the correct
    set of patches:
    - Remove patches/any/submitted-origin.diff
    - Add patches/any/cvs-dont-expand-dst-twice.diff
    - Add debian/patches/any/cvs-ignore-origin-privileged.diff
    - Keep debian/patches/any/cvs-audit-suid.diff

  [ ncurses (5.7+20100313-5) unstable; urgency=low ]

  * New patch 01-debian-kfreebsd-terminfo.patch, adding a cons25-debian
    terminfo entry to ncurses-base for the Debian GNU/kfreebsd console
    (#607662).

 -- Goswin von Brederlow <goswin-v-b@web.de>  Wed, 02 Feb 2011 21:38:44 +0100

ia32-libs-core (20101207) unstable; urgency=high

  [ Goswin von Brederlow ]
  * Sync fetch-and-build script with ia32-libs / ia32-libs-gtk.
    One script fits all.
  * Readd Breaks statement as per policy 7.6.1.
	
  * Packages updated

  [ gcc-4.4 (4.4.5-8) unstable; urgency=low ]

  * Update to SVN 20101114 from the gcc-4_4-branch (r166728).
    - Fix PR middle-end/43690, PR tree-optimization/46107, PR libgfortran/46373,
      PR fortran/45742.
  * Don't hardcode debian/patches when referencing patches. Addresses: #600502.

  [ gcc-4.4 (4.4.5-7) unstable; urgency=low ]

  * Update to SVN 20101111 from the gcc-4_4-branch (r166584).
    - Fix PR target/46419 (wrong code), PR libgfortran/46010 (wrong code).

  [ Thorsten Glaser ]
  * debian/rules2: Re-enable multi{arch,lib} on m68k.
  * debian/patches/m68k-multilib.diff: new, select which multi{arch,lib}
    targets to build: keep 680x0 drop cpu32/fidoa (possibly re-evaluated
    later but [Bug gas/12180] suggests both do not run Linux anyway).
  * debian/patches/pr37053.diff: new, backported from trunk.
  * debian/patches/pr46179.diff: new, taken from GCC BZ.
  * debian/patches/pr39531.diff: new, taken from git URL from fthain.
  * debian/patches/pr41064.diff: new, backported from trunk.
  * debian/rules.patch: Add m68k-multilib, pr37053, pr46179, pr39531,
    pr41064 on m68k. (pr37053 and pr41064 go together to avoid regressions.)
  * debian/rules.defs: remove m68k from locale_no_cpus.

  [ icu (4.4.1-7) testing-proposed-updates; urgency=high ]

  * Apply patch to fix Malayam rendering.  (#591615)

 -- Goswin von Brederlow <goswin-v-b@web.de>  Tue, 07 Dec 2010 17:33:45 +0100

ia32-libs-core (20101117) unstable; urgency=low

  [ Goswin von Brederlow ]
  * Replace lib32icu42 with lib32icu44.
  * Update Packages:
    + alsa-lib  1.0.22-2       -> 1.0.23-2.1
    + blcr      0.8.2-13       -> 0.8.2-15
    + bzip2     1.0.5-4        -> 1.0.5-6
    + eglibc    2.10.2-9       -> 2.11.2-7
    + gcc       4.4_4.4.4-1    -> 4.4_4.4.5-6
    + icu       4.2.1-3        -> 4.4.1-6
    + libffi    3.0.9-2        -> 3.0.9-3
    + ncurses   5.7+20100313-2 -> 5.7+20100313-4
 
 -- Goswin von Brederlow <goswin-v-b@web.de>  Wed, 17 Nov 2010 11:36:10 +0100

ia32-libs-core (20100610) unstable; urgency=low

  [ Goswin von Brederlow ]
  * Convert to 3.0 (native) format.
  * Add debian/source/options to ignore locale files.

  [ Frederik Schüler ]
  * Update to debhelper 7.
    - use dh_prep instead of dh_clean -k
  * Add dependency on ${misc:Depends}.
  * Add lintian overides.

 -- Frederik Schüler <fs@debian.org>  Thu, 10 Jun 2010 17:00:37 +0200

ia32-libs-core (20100421) unstable; urgency=low

  * Split ia64 specific packages from ia32-libs into ia32-libs-core.

 -- Goswin von Brederlow <goswin-v-b@web.de>  Wed, 21 Apr 2010 09:09:11 +0200

ia32-libs (20090808) unstable; urgency=low

  * Update packages.
  * Automatically generate copyright file.  Closes: #540199, #505625.
  * Add libuuid1.  Closes: #540489, #540339, #539746.
  * Bump shlibs version to 20090808.  Closes: #540184.
  * B-D on dctrl-tools instead of grep-dctrl.  Closes: #505631.
  * Add locale symlink.  Thanks to Martin Pitt.  Closes: #505627.
  * Use ROOT/SUFFIX consistently in debian/rules.  Thanks to Martin Pitt.
    Closes: #505632.

 -- Mark Hymers <mhy@debian.org>  Sat, 08 Aug 2009 18:12:19 +0100

ia32-libs (20090804) unstable; urgency=low

  * Re-upload monolithic package.
  * Drop gdk-imlib1, gdk-imlib11, libcap1, libfusionsound-1.0-0, libxcb-xlib0
  * Bump libdirectfb to 1.2-0 from 1.0-0, libltdl3 to libltdl7
  * Replace libkrb53 with libkrb5support0, libkrb5-3, libk5crypto3,
    libgssapi-krb5-2

 -- Mark Hymers <mhy@debian.org>  Tue, 04 Aug 2009 21:35:25 +0100

ia32-libs (2.7) unstable; urgency=low

  * Freshen packages.
  * Drop libgnutls13 and libopencdk10: removed from lenny.

 -- Frederik Schüler <fs@debian.org>  Wed, 03 Sep 2008 20:40:18 +0200

ia32-libs (2.6) unstable; urgency=low

  [ Goswin von Brederlow ]
  * Fix echo -e bashism in debian/rules (Closes: 484391)

  [ Frederik Schüler ]
  * drop libldap2 and liblzo1.
  * Add libxcb1, libxcb-xlib0, libxcb-render0 and libxcb-render-util0 -
    new dependencies from libaudio2.
  * Replace libcupsys2 with libcups2.
  * Freshen packages.

 -- Frederik Schüler <fs@debian.org>  Wed, 23 Jul 2008 13:36:03 +0200

ia32-libs (2.5) unstable; urgency=low



=== control ===
Source: v4l-utils
Section: video
Priority: optional
Maintainer: Gregor Jasny <gjasny@googlemail.com>
Uploaders: Martin Pitt <mpitt@debian.org>,
           Loic Minier <lool@dooz.org>
Build-Depends: debhelper (>= 7),
               libqt4-dev,
               libsysfs-dev,
               linux-libc-dev (>= 2.6.19),
               gcc-multilib [amd64]
Standards-Version: 3.8.4
Vcs-Browser: http://git.debian.org/?p=collab-maint/libv4l.git
Vcs-Git: git://git.debian.org/git/collab-maint/libv4l.git
Homepage: http://linuxtv.org/downloads/v4l-utils/

Package: libv4l-0
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Collection of video4linux support libraries
 libv4l is a collection of libraries which adds a thin abstraction layer on
 top of video4linux2 devices. The purpose of this (thin) layer is to make it
 easy for application writers to support a wide variety of devices without
 having to write separate code for different devices in the same class. libv4l
 consists of 3 different libraries: libv4lconvert, libv4l1 and libv4l2.
 .
 libv4lconvert offers functions to convert from any (known) pixelformat
 to BGR24, RGB24, YUV420 and YVU420.
 .
 libv4l1 offers the (deprecated) v4l1 API on top of v4l2 devices, independent
 of the drivers for those devices supporting v4l1 compatibility (which many
 v4l2 drivers do not).
 .
 libv4l2 offers the v4l2 API on top of v4l2 devices, while adding for the
 application transparent libv4lconvert conversion where necessary.
 .
 This package contains the shared libraries.

Package: libv4l-dev
Section: libdevel
Architecture: any
Depends: libv4l-0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: pkg-config (>= 0.18)
Description: Collection of video4linux support libraries (development files)
 libv4l is a collection of libraries which adds a thin abstraction layer on
 top of video4linux2 devices. The purpose of this (thin) layer is to make it
 easy for application writers to support a wide variety of devices without
 having to write separate code for different devices in the same class. libv4l
 consists of 3 different libraries: libv4lconvert, libv4l1 and libv4l2.
 .
 libv4lconvert offers functions to convert from any (known) pixelformat
 to BGR24, RGB24, YUV420 and YVU420.
 .
 libv4l1 offers the (deprecated) v4l1 API on top of v4l2 devices, independent
 of the drivers for those devices supporting v4l1 compatibility (which many
 v4l2 drivers do not).
 .
 libv4l2 offers the v4l2 API on top of v4l2 devices, while adding for the
 application transparent libv4lconvert conversion where necessary.
 .
 This package contains development files (headers and static libraries).

Package: lib32v4l-0
Section: libs
Architecture: amd64
Depends: libv4l-0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Collection of video4linux support libraries (32 bits)
 libv4l is a collection of libraries which adds a thin abstraction layer on
 top of video4linux2 devices. The purpose of this (thin) layer is to make it
 easy for application writers to support a wide variety of devices without
 having to write separate code for different devices in the same class. libv4l
 consists of 3 different libraries: libv4lconvert, libv4l1 and libv4l2.
 .
 libv4lconvert offers functions to convert from any (known) pixelformat
 to BGR24, RGB24, YUV420 and YVU420.
 .
 libv4l1 offers the (deprecated) v4l1 API on top of v4l2 devices, independent
 of the drivers for those devices supporting v4l1 compatibility (which many
 v4l2 drivers do not).
 .
 libv4l2 offers the v4l2 API on top of v4l2 devices, while adding for the
 application transparent libv4lconvert conversion where necessary.
 .
 This package contains the 32 bits version of the shared libraries.

Package: lib32v4l-dev
Section: libdevel
Architecture: amd64
Depends: libv4l-0 (= ${binary:Version}),
         lib32v4l-0 (= ${binary:Version}),
         libv4l-dev (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Collection of video4linux support libraries (32 bits development files)
 libv4l is a collection of libraries which adds a thin abstraction layer on
 top of video4linux2 devices. The purpose of this (thin) layer is to make it
 easy for application writers to support a wide variety of devices without
 having to write separate code for different devices in the same class. libv4l
 consists of 3 different libraries: libv4lconvert, libv4l1 and libv4l2.
 .
 libv4lconvert offers functions to convert from any (known) pixelformat
 to BGR24, RGB24, YUV420 and YVU420.
 .
 libv4l1 offers the (deprecated) v4l1 API on top of v4l2 devices, independent
 of the drivers for those devices supporting v4l1 compatibility (which many
 v4l2 drivers do not).
 .
 libv4l2 offers the v4l2 API on top of v4l2 devices, while adding for the
 application transparent libv4lconvert conversion where necessary.
 .
 This package contains the 32 bits version of the development files (headers
 and static libraries).

Package: v4l-utils
Section: utils
Architecture: any
Depends: libv4l-0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Conflicts: ivtv-utils
Description: Collection of command line video4linux utilities
 v4l-utils contains the following video4linux command line utilities:
 .
  decode_tm6000: decodes tm6000 proprietary format streams
  v4l2-compliance: tool to test v4l2 API compliance of drivers
  v4l2-ctl, cx18-ctl, ivtv-ctl: tools to control v4l2 controls from the cmdline
  v4l2-dbg: tool to directly get and set registers of v4l2 devices
  v4l2-sysfs-path: sysfs helper tool

Package: qv4l2
Section: utils
Architecture: any
Depends: libv4l-0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Graphical Qt v4l2 control panel
 Qt v4l2 control panel application. You can change all through the v4l2
 interface exposed device controls.

=== debian/control ===
Source: ia32-libs-core
Section: libs
Priority: extra
Maintainer: Debian ia32-libs Team <pkg-ia32-libs-maintainers@lists.alioth.debian.org>
Uploaders: Bdale Garbee <bdale@gag.com>, Goswin von Brederlow <goswin-v-b@web.de>, Frederik Schüler <fs@debian.org>, Thijs Kinkhorst <thijs@debian.org>
Build-Depends: debhelper (>> 7.0.0), dpkg-dev (>= 1.15.7.2), lsb-release, dctrl-tools
Standards-Version: 3.8.4
Vcs-Browser: http://git.debian.org/?p=pkg-ia32-libs/ia32-libs-core.git
Vcs-Git: git://git.debian.org/git/pkg-ia32-libs/ia32-libs-core.git

Package: ia32-libs-core
Architecture: ia64
Pre-Depends: dpkg (>= 1.13.21)
Depends: ${misc:Depends}
Replaces: ia32-libs (<< 20100418), ia32-libs-dev (<< 1.6), nvidia-glx-ia32 (<< 1.0.8774-7)
Breaks: ia32-libs (<< 20100418), nvidia-glx-ia32 (<< 1.0.8774-7)
Conflicts: ia32-libs-dev
Suggests: ia32-libs
Description: core ia32 shared libraries for use on ia64 systems
 This package contains runtime linker and core libraries for the ia32/i386
 architecture, configured for use on an ia64 Debian system.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Lowest version with fully ABI compatible libraries
SHLIB_VERSION = $(shell dpkg-parsechangelog | sed -n 's/Version: \(.*\)/\1/p')

ROOT=/
ROOTL=
SUFFIX=32
SUFFIXL=32

build:
#	./fetch-and-build

clean:
	dh_testdir
	dh_testroot
	dh_clean

install-prefix:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

######################################################################
# common variables
######################################################################

MAKE := $(MAKE) -f debian/rules
DEBS_ia32-libs-core := $(shell cd pkgs; ls *.deb | cut -d"_" -f1)

EXTRACT_ia32-libs-core := $(addprefix extract-,$(DEBS_ia32-libs-core))

######################################################################
# common helper
######################################################################
# All helpers expect DEST to be set to debian/<pkg>

.PRECIOUS: %/DEBIAN/Manifest
%/DEBIAN/Manifest:
	mkdir -p $(DEST)/DEBIAN/
	echo "# packages used in the creation of $(notdir $(DEST))" \
	     > $(DEST)/DEBIAN/Manifest
	echo >> $(DEST)/DEBIAN/Manifest

extract-%: $(DEST)/DEBIAN/Manifest
	cd pkgs && echo $*_*.deb >> ../$(DEST)/DEBIAN/Manifest
	dpkg-deb -x pkgs/$*_*.deb $(DEST)

	# change shlibs information
	# libX Y * ---> libX Y <DEST> (>= SHLIB_VERSION)
	mkdir -p $(DEST)/t/DEBIAN
	dpkg-deb -e pkgs/$*_*.deb $(DEST)/t/DEBIAN
	if [ -f $(DEST)/t/DEBIAN/shlibs ]; then \
	  grep -v "^udeb:" < $(DEST)/t/DEBIAN/shlibs \
	  | sed "s/^\(\S*\s*\S*\).*/\1 $(notdir $(DEST)) (>= $(SHLIB_VERSION))/" >>$(DEST)/DEBIAN/shlibs; \
	fi
	rm -r $(DEST)/t/DEBIAN

move-libs:
	# Move libraries to new places
	[ ! -d $(DEST)/t/lib ] \
	|| ( mkdir -p $(DEST)$(ROOT) \
	   && mv $(DEST)/t/lib $(DEST)$(ROOT)lib$(SUFFIX) )
	[ ! -d $(DEST)/t/usr/lib ] \
	|| ( mkdir -p $(DEST)$(ROOT)usr \
	   && mv $(DEST)/t/usr/lib $(DEST)$(ROOT)usr/lib$(SUFFIX) )

move-docs: PKG=$(notdir $(DEST))
move-docs:
	mkdir -p $(DEST)/DEBIAN/t
	mv $(DEST)/usr/share/doc/* $(DEST)/DEBIAN/t/
	mv $(DEST)/DEBIAN/t $(DEST)/usr/share/doc/$(PKG)

fix-links:
	# change links in $(DEST)$(ROOT) to new names
	for link in $$(find $(DEST)$(ROOT) -type l); do		\
	  dest=$$(readlink $$link);				\
	  case "$$dest" in					\
	    /etc*) ;;						\
	    /usr/lib/locale*) ;;				\
	    /*) rm -f $$link;					\
	        ln -s $$(echo $$dest | sed -e 's,^/,$(ROOT),' -e 's,/lib/,/lib$(SUFFIX)/,') $$link;	\
	        ;;						\
	  esac;							\
	done

######################################################################
# ia32-libs-core
######################################################################
install-ia32-libs-core: DEST=debian/ia32-libs-core
install-ia32-libs-core: install-prefix
	# Extract all debs
	$(MAKE) DEST=$(DEST) $(EXTRACT_ia32-libs-core)

	# Move and rename docs
	$(MAKE) DEST=$(DEST) move-docs

	# Add locale symlink
	#ln -s /usr/lib/locale $(DEST)$(ROOT)usr/lib$(SUFFIX)/locale

	# Remove unwanted directories and files
	rm -rf $(DEST)/t
	rm -rf $(DEST)/usr/share/lintian/overrides
	rm -rf $(DEST)/usr/share/alsa
	rm -rf $(DEST)/usr/lib

	# Add lintian overrides and Manifest
	mkdir -p $(DEST)/usr/share/lintian/overrides
	cp debian/ia32-libs-core.overrides $(DEST)/usr/share/lintian/overrides/ia32-libs-core
	mv $(DEST)/DEBIAN/Manifest $(DEST)/usr/share/doc/ia32-libs-core/Manifest.ia32-libs-core

	# Fix symlinks.
	$(MAKE) DEST=$(DEST) fix-links

	# Fix duplicate shlibs entries
	sort -u $(DEST)/DEBIAN/shlibs >$(DEST)/DEBIAN/shlibs.new
	mv $(DEST)/DEBIAN/shlibs.new $(DEST)/DEBIAN/shlibs

install: install-ia32-libs-core

binary-indep:


# Build architecture-dependent files here.

binary-arch: build install
	dh_testdir -s
	dh_testroot -s 
	dh_installdocs -s
	dh_installexamples -s
	dh_installchangelogs -s
	dh_link
	dh_lintian
	dh_compress -s
	dh_fixperms --exclude "*/ld-*" -s
	dh_installdeb -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== rules ===
#!/usr/bin/make -f
# -*- makefile -*-

soversion = 6
libversion = $(soversion).1

# architecture dependent variables
DEB_HOST_ARCH		?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS	?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS=$(DEB_HOST_GNU_TYPE)-gcc
else
CROSS=gcc
endif
distribution := $(shell lsb_release -is)

ifneq (,$(findstring /$(DEB_HOST_ARCH)/,/i386/powerpc/sparc/s390/))
  build64 = yes
  CC64 = $(CROSS) -m64
  gencontrol_flags = -- \
	'-Vdevxx:Depends=libc6-dev-$(ARCH64)'
  ifeq ($(DEB_HOST_ARCH),i386)
    ARCH64 = amd64
    HOST64 = x86_64-linux-gnu
  endif
  ifeq ($(DEB_HOST_ARCH),powerpc)
    ARCH64 = ppc64
    HOST64 = ppc64-linux-gnu
  endif
  ifeq ($(DEB_HOST_ARCH),sparc)
    ARCH64 = sparc64
    HOST64 = sparc64-linux-gnu
  endif
  ifeq ($(DEB_HOST_ARCH),s390)
    ARCH64 = s390x
    HOST64 = s390x-linux-gnu
  endif
endif

ifneq (,$(findstring /$(DEB_HOST_ARCH)/,/amd64/ppc64/))
  build32 = yes
  CC32 = $(CROSS) -m32
  lib32dir = lib32
  lib32devdir = usr/lib32
  gencontrol_flags = -- \
	'-Vdevxx:Depends=libc6-dev-$(ARCH32)'
  ifeq ($(DEB_HOST_ARCH),amd64)
    ARCH32 = i386
    HOST32 = i486-linux-gnu
  endif
  ifeq ($(DEB_HOST_ARCH),ppc64)
    ARCH32 = powerpc
    HOST32 = powerpc-linux-gnu
  endif
endif

ifeq ($(DEB_HOST_ARCH_OS),netbsd)
  CC_LINK_FLAGS =
else
  CC_LINK_FLAGS = -Wl,
endif
CC	= $(CROSS)

SHELL	= bash

p_rl	= libreadline$(soversion)
p_rl32	= lib32readline$(soversion)
p_rl64	= lib64readline$(soversion)
p_comm	= readline-common
p_rldnv	= libreadline-dev
p_rld	= $(p_rl)-dev
p_rld32	= $(p_rl32)-dev
p_rld64	= $(p_rl64)-dev
p_rlg	= $(p_rl)-dbg
p_doc	= $(p_rl)-doc
p_rlfe	= rlfe

d	= debian/tmp
d32	= debian/tmp32
d64	= debian/tmp64
d_rl	= debian/$(p_rl)
d_rl32	= debian/$(p_rl32)
d_rl64	= debian/$(p_rl64)
d_comm	= debian/$(p_comm)
d_rldnv	= debian/$(p_rldnv)
d_rld	= debian/$(p_rld)
d_rld32	= debian/$(p_rld32)
d_rld64	= debian/$(p_rld64)
d_rlg	= debian/$(p_rlg)
d_doc	= debian/$(p_doc)
d_rlfe	= debian/$(p_rlfe)

srcdir		= $(CURDIR)
builddir	= $(CURDIR)/build
builddir32	= $(CURDIR)/build32
builddir64	= $(CURDIR)/build64

default: build

configure: configure-stamp
configure-stamp:
	dh_testdir
	cp -p /usr/share/misc/config.* ./support/
	rm -rf $(builddir)
	mkdir $(builddir)
	find . -type d | xargs chmod g-s
	cd $(builddir) && \
	  CC=$(CC) $(srcdir)/configure \
		--with-curses --prefix=/usr\
		--host=$(DEB_HOST_GNU_TYPE)

ifneq ($(build32),)
	rm -rf $(builddir32)
	mkdir $(builddir32)
	cd $(builddir32) && \
	  CC="$(CC32)" $(srcdir)/configure \
		--host=$(HOST32) --with-curses --prefix=/usr
endif

ifneq ($(build64),)
	rm -rf $(builddir64)
	mkdir $(builddir64)
	cd $(builddir64) && \
	  CC="$(CC64)" $(srcdir)/configure \
		--host=$(HOST64) --with-curses --prefix=/usr
endif

	touch configure-stamp

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
build: build-stamp build-rlfe-stamp
else
build: build-stamp
endif

build-stamp: configure-stamp
	dh_testdir
	$(MAKE) -C $(builddir) \
	    CFLAGS="-g -O2" \
	    SHOBJ_CFLAGS="-fPIC -D_REENTRANT" \
	    SHLIB_LIBS="-lncurses"

ifneq ($(build32),)
	$(MAKE) -C $(builddir32) \
	    CC="$(CC32)" \
	    CFLAGS="-g -O2" \
	    SHOBJ_CFLAGS="-fPIC -D_REENTRANT" \
	    SHOBJ_LDFLAGS='-shared' \
	    SHLIB_LIBS="-lncurses" \
	    SHLIB_XLDFLAGS='$(CC_LINK_FLAGS)-soname,`echo $$@ | sed s/\\..$$$$//`'
endif

ifneq ($(build64),)
	$(MAKE) -C $(builddir64) \
	    CC="$(CC64)" \
	    CFLAGS="-g -O2" \
	    SHOBJ_CFLAGS="-fPIC -D_REENTRANT" \
	    SHOBJ_LDFLAGS='-shared' \
	    SHLIB_LIBS="-lncurses" \
	    SHLIB_XLDFLAGS='$(CC_LINK_FLAGS)-soname,`echo $$@ | sed s/\\..$$$$//`'
endif
	$(MAKE) -C $(builddir)/doc info

	touch build-stamp

build-rlfe-stamp: configure-stamp
	dh_testdir
	ln -sf libhistory.so.$(libversion) \
	    $(builddir)/shlib/libhistory.so.$(soversion)
	ln -sf libhistory.so.$(soversion) $(builddir)/shlib/libhistory.so
	ln -sf libreadline.so.$(libversion) \
	    $(builddir)/shlib/libreadline.so.$(soversion)
	ln -sf libreadline.so.$(soversion) $(builddir)/shlib/libreadline.so
	rm -rf $(builddir)/examples/rlfe
	cp -a examples/rlfe $(builddir)/examples/
	ln -sf ../../.. $(builddir)/examples/rlfe/readline
	cd $(builddir)/examples/rlfe \
		&& ./configure --prefix=/usr --host=$(DEB_HOST_GNU_TYPE)
	$(MAKE) -C $(builddir)/examples/rlfe \
	    CFLAGS="-g -O2" LDFLAGS="-g -L$(builddir)/shlib" rlfe
	touch build-rlfe-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f configure*-stamp build*-stamp install-stamp
	rm -rf autom4te.cache
	rm -rf $(builddir) $(builddir32) $(builddir64)
	rm -rf debian/tmp*
	rm -f doc/*.dvi
	rm -f debian/shlibs.local
	find . -type d | xargs chmod g-s
	rm -f support/config.guess support/config.sub
	dh_clean

install: install-stamp
install-stamp:
	dh_testdir
	dh_testroot
	dh_clean -k
	rm -rf $(d)
	mkdir -p $(d)/usr/bin
	$(MAKE) -C $(builddir) install \
	    CFLAGS="-g -O2 -D_REENTRANT" \
	    DESTDIR=$(CURDIR)/$(d) \
	    mandir=/usr/share/man \
	    infodir=/usr/share/info

	: # move $(p_rl)
	dh_installdirs -p$(p_rl) \
		etc \
		lib \
		usr/share/doc
	cp -a $(d)/usr/lib/lib{history,readline}.so.* $(d_rl)/lib/
#	cp -a $(d)/usr/lib/lib{history,readline}.so.$(libversion) $(d_rl)/lib/
#	ln -s libhistory.so.$(libversion) \
#		$(d_rl)/lib/libhistory.so.$(soversion)
#	ln -s libreadline.so.$(libversion) \
#		$(d_rl)/lib/libreadline.so.$(soversion)

	: # move $(p_comm)
	dh_installdirs -p$(p_comm) \
		etc \
		usr/share/readline \
		usr/share/info \
		usr/share/doc
	mv $(d)/usr/share/man $(d_comm)/usr/share/.
	mv $(d_comm)/usr/share/man/man3/history.3 \
		$(d_comm)/usr/share/man/man3/history.3readline
	mv $(d_comm)/usr/share/man/man3/readline.3 \
		$(d_comm)/usr/share/man/man3/readline.3readline
	mv $(d)/usr/share/info/rluserman.info $(d_comm)/usr/share/info/.
	install -m 644 debian/inputrc $(d_comm)/usr/share/readline/

	: # move $(p_rlg)
	dh_installdirs -p$(p_rlg) \
		usr/lib/debug \
		usr/share/doc
	mv $(d)/usr/lib/lib{history,readline}.so.$(libversion) \
		$(d_rlg)/usr/lib/debug/.
	ln -s libhistory.so.$(libversion) \
		$(d_rlg)/usr/lib/debug/libhistory.so.$(soversion)
	ln -s libreadline.so.$(libversion) \
		$(d_rlg)/usr/lib/debug/libreadline.so.$(soversion)

	: # move $(p_rld)
	dh_installdirs -p$(p_rld) \
		usr/lib \
		usr/share/doc \
		usr/share/info
	ln -s /lib/libhistory.so.$(soversion) $(d_rld)/usr/lib/libhistory.so
	ln -s /lib/libreadline.so.$(soversion) $(d_rld)/usr/lib/libreadline.so
	mv $(d)/usr/lib/lib{history,readline}.a	$(d_rld)/usr/lib/.
	mv $(d)/usr/include $(d_rld)/usr/.
	mv $(d)/usr/share/info/{readline.info,history.info} \
		$(d_rld)/usr/share/info/.

	: # remove HAVE_CONFIG_H from installed headers
	awk '/^#if defined \(HAVE_CONFIG_H\)/, /^#endif/ \
	     {if ($$0 == "#else") print "#include <string.h>"; next} {print}' \
	  $(d_rld)/usr/include/readline/chardefs.h \
	  > $(d_rld)/usr/include/readline/chardefs.h.new
	if diff -u $(d_rld)/usr/include/readline/chardefs.h \
		$(d_rld)/usr/include/readline/chardefs.h.new; \
	then \
	  rm -f $(d_rld)/usr/include/readline/chardefs.h.new; \
	else \
	  mv -f $(d_rld)/usr/include/readline/chardefs.h.new \
	    $(d_rld)/usr/include/readline/chardefs.h; \
	fi

	: # install $(p_rlfe)
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	dh_installdirs -p$(p_rlfe) \
	    usr/bin usr/share/man/man1 \
	    usr/share/doc/$(p_rlfe)
	cp -p $(builddir)/examples/rlfe/rlfe $(d_rlfe)/usr/bin/.
	cp -p debian/rlfe.1 $(d_rlfe)/usr/share/man/man1/.
endif

ifneq ($(build32),)
	rm -rf $(d32)
	mkdir -p $(d32)/usr/bin
	$(MAKE) -C $(builddir32) install \
	    CC="$(CC32)" \
	    CFLAGS="-g -O2 -D_REENTRANT" \
	    SHOBJ_LDFLAGS='-shared' \
	    SHLIB_XLDFLAGS='$(CC_LINK_FLAGS)-soname,`echo $$@ | sed s/\\..$$$$//`' \
	    SHLIB_LIBS=-lncurses \
	    DESTDIR=$(CURDIR)/$(d32) \
	    mandir=/usr/share/man \
	    infodir=/usr/share/info

=== watch ===
version=3
https://ftg.lbl.gov/CheckpointRestart/downloads/blcr-(\d\.\d\.\d).tar.gz
